/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of MPC.xs. Do not edit this file, edit MPC.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MPC.xs"

#ifdef  __MINGW32__
#ifndef __USE_MINGW_ANSI_STDIO
#define __USE_MINGW_ANSI_STDIO 1
#endif
#endif

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"


#include "math_mpc_include.h"

#define MY_CXT_KEY "Math::MPC::_guts" XS_VERSION

typedef struct {
  mp_prec_t _perl_default_prec_re;
  mp_prec_t _perl_default_prec_im;
  mpc_rnd_t _perl_default_rounding_mode;
} my_cxt_t;

START_MY_CXT

#define DEFAULT_PREC MY_CXT._perl_default_prec_re,MY_CXT._perl_default_prec_im
#define DEFAULT_PREC_RE MY_CXT._perl_default_prec_re
#define DEFAULT_PREC_IM MY_CXT._perl_default_prec_im
#define DEFAULT_ROUNDING_MODE MY_CXT._perl_default_rounding_mode

/* These (CXT) values set at boot ... MPC_RNDNN == 0 */
/*
mpc_rnd_t _perl_default_rounding_mode = MPC_RNDNN;
mp_prec_t _perl_default_prec_re = 53;
mp_prec_t _perl_default_prec_im = 53;
*/

int nok_pok = 0; /* flag that is incremented whenever a scalar that is both
                 NOK and POK is passed to new or an overloaded operator */

int NOK_POK_val(pTHX) {
  /* return the numeric value of $Math::MPC::NOK_POK */
  return SvIV(get_sv("Math::MPC::NOK_POK", 0));
}

int _win32_infnanstring(char * s) { /* MS Windows only - detect 1.#INF and 1.#IND
                                     * Need to do this to correctly handle an inf/nan
                                     * scalar that is both NOK and POK on older win32 perls */

  /*************************************
  * if input string    =~ /^\-1\.#INF$/ return -1
  * elsif input string =~ /^\+?1\.#INF$/i return 1
  * elsif input string =~ /^(\-|\+)?1\.#IND$/i return 2
  * else return 0
  **************************************/
#ifdef _WIN32_BIZARRE_INFNAN
  int sign = 1;
  int factor = 1;

  if(s[0] == '-') {
    sign = -1;
    s++;
  }
  else {
    if(s[0] == '+') s++;
  }

  if(!strcmp(s, "1.#INF")) return sign;
  if(!strcmp(s, "1.#IND")) return 2;

  return 0;
#else
  croak("Math::MPC::_win32_infnanstring not implemented for this build of perl");
#endif
}

/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_mul_sj (mpc_ptr rop, mpc_ptr op, intmax_t i, mpc_rnd_t rnd) {

#ifdef MATH_MPC_NEED_LONG_LONG_INT

   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(intmax_t) * CHAR_BIT);
   mpfr_set_sj (x, i, GMP_RNDN);

   inex = mpc_mul_fr (rop, op, x, rnd);

   mpfr_clear (x);
   return inex;
}

#else

   croak("Rmpc_mul_sj not implememnted on this build of perl");
}

#endif


/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_mul_ld (mpc_ptr rop, mpc_ptr op, long double i, mpc_rnd_t rnd) {

#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)

   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(long double) * CHAR_BIT);
   mpfr_set_ld (x, i, GMP_RNDN);

   inex = mpc_mul_fr (rop, op, x, rnd);

   mpfr_clear (x);
   return inex;
}

#else

   croak("Rmpc_mul_ld not implememnted on this build of perl");
}

#endif


/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_mul_d (mpc_ptr rop, mpc_ptr op, double i, mpc_rnd_t rnd) {
   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(double) * CHAR_BIT);
   mpfr_set_d (x, i, GMP_RNDN);

   inex = mpc_mul_fr (rop, op, x, rnd);

   mpfr_clear (x);
   return inex;
}


/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_div_sj (mpc_ptr rop, mpc_ptr op, intmax_t i, mpc_rnd_t rnd) {

#ifdef MATH_MPC_NEED_LONG_LONG_INT

   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(intmax_t) * CHAR_BIT);
   mpfr_set_sj (x, i, GMP_RNDN);

   inex = mpc_div_fr (rop, op, x, rnd);

   mpfr_clear (x);
   return inex;
}

#else

   croak("Rmpc_div_sj not implememnted on this build of perl");
}

#endif


/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_sj_div (mpc_ptr rop, intmax_t i, mpc_ptr op, mpc_rnd_t rnd) {

#ifdef MATH_MPC_NEED_LONG_LONG_INT

   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(intmax_t) * CHAR_BIT);
   mpfr_set_sj (x, i, GMP_RNDN);

   inex = mpc_fr_div (rop, x, op, rnd);

   mpfr_clear (x);
   return inex;
}

#else

   croak("Rmpc_sj_div not implememnted on this build of perl");
}

#endif


/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_div_ld (mpc_ptr rop, mpc_ptr op, long double i, mpc_rnd_t rnd) {

#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)

   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(long double) * CHAR_BIT);
   mpfr_set_ld (x, i, GMP_RNDN);

   inex = mpc_div_fr (rop, op, x, rnd);

   mpfr_clear (x);
   return inex;
}

#else

   croak("Rmpc_div_ld not implememnted on this build of perl");
}

#endif


/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_ld_div (mpc_ptr rop, long double i, mpc_ptr op, mpc_rnd_t rnd) {

#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)

   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(long double) * CHAR_BIT);
   mpfr_set_ld (x, i, GMP_RNDN);

   inex = mpc_fr_div (rop, x, op, rnd);

   mpfr_clear (x);
   return inex;
}

#else

   croak("Rmpc_ld_div not implememnted on this build of perl");
}

#endif

/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_div_d (mpc_ptr rop, mpc_ptr op, double i, mpc_rnd_t rnd) {
   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(double) * CHAR_BIT);
   mpfr_set_d (x, i, GMP_RNDN);

   inex = mpc_div_fr (rop, op, x, rnd);

   mpfr_clear (x);
   return inex;
}


/* This function is based on some code posted by Philippe Theveny. */

int Rmpc_d_div (mpc_ptr rop, double i, mpc_ptr op, mpc_rnd_t rnd) {
   mpfr_t x;
   int inex;

   mpfr_init2 (x, sizeof(double) * CHAR_BIT);
   mpfr_set_d (x, i, GMP_RNDN);

   inex = mpc_fr_div (rop, x, op, rnd);

   mpfr_clear (x);
   return inex;
}


SV * _mpfr_set_NV(pTHX_ mpfr_t * p, SV * q, unsigned int round) {

#if defined(MPC_CAN_PASS_FLOAT128)

     if(!SvNOK(q)) croak("Second arg given to Rmpfr_set_NV is not an NV");

     return newSViv(mpfr_set_float128(*p, (float128)SvNVX(q), (mp_rnd_t)round));

#elif defined(NV_IS_FLOAT128)

     char * buffer;
     int exp, exp2 = 0;
     float128 ld, buffer_size;
     int returned;

     if(!SvNOK(q)) croak("Second arg given to Math::MPC::_mpfr_set_NV is not an NV");


     ld = (float128)SvNVX(q);

     if(ld != ld) {
       mpfr_set_nan(*p);
       return newSViv(0);
     }

     if(ld != 0.0Q && (ld / ld != 1)) {
       returned = ld > 0.0Q ? 1 : -1;
       mpfr_set_inf(*p, returned);
       return newSViv(0);
     }

     ld = frexpq((float128)SvNVX(q), &exp);

     while(ld != floorq(ld)) {
          ld *= 2;
          exp2 += 1;
     }

     buffer_size = ld < 0.0Q ? ld * -1.0Q : ld;
     buffer_size = ceilq(logq(buffer_size + 1) / 2.30258509299404568401799145468436418Q);

     Newxz(buffer, buffer_size + 5, char);

     returned = quadmath_snprintf(buffer, (size_t)buffer_size + 5, "%.0Qf", ld);
     if(returned < 0) croak("In Math::MPC::_mpfr_set_NV, encoding error in quadmath_snprintf function");
     if(returned >= buffer_size + 5) croak("In Math::MPC::_mpfr_set_NV, buffer given to quadmath_snprintf function was too small");
     returned = mpfr_set_str(*p, buffer, 10, (mp_rnd_t)round);
     Safefree(buffer);

     if (exp2 > exp) mpfr_div_2ui(*p, *p, exp2 - exp, GMP_RNDN);
     else mpfr_mul_2ui(*p, *p, exp - exp2, GMP_RNDN);
     return newSViv(returned);

#elif defined(NV_IS_LONG_DOUBLE) && !defined(_MSC_VER)

     if(!SvNOK(q)) croak("Second arg given to Math::MPC::_mpfr_set_NV is not an NV");

     return newSViv(mpfr_set_ld(*p, (long double)SvNVX(q), (mp_rnd_t)round));

#else

     if(!SvNOK(q)) croak("Second arg given to Math::MPC::_mpfr_set_NV is not an NV");

     return newSViv(mpfr_set_d (*p, (double)SvNVX(q), (mp_rnd_t)round));
#endif
}

void Rmpc_set_default_rounding_mode(pTHX_ SV * round) {
     dMY_CXT;
     DEFAULT_ROUNDING_MODE = (mpc_rnd_t)SvUV(round);
}

SV * Rmpc_get_default_rounding_mode(pTHX) {
     dMY_CXT;
     return newSVuv(DEFAULT_ROUNDING_MODE);
}

void Rmpc_set_default_prec(pTHX_ SV * prec) {
     dMY_CXT;
     DEFAULT_PREC_RE = (mp_prec_t)SvUV(prec);
     DEFAULT_PREC_IM = (mp_prec_t)SvUV(prec);
}

void Rmpc_set_default_prec2(pTHX_ SV * prec_re, SV * prec_im) {
     dMY_CXT;
     DEFAULT_PREC_RE = (mp_prec_t)SvUV(prec_re);
     DEFAULT_PREC_IM = (mp_prec_t)SvUV(prec_im);
}

SV * Rmpc_get_default_prec(pTHX) {
     dMY_CXT;
     if(DEFAULT_PREC_RE == DEFAULT_PREC_IM)
       return newSVuv(DEFAULT_PREC_RE);
     return newSVuv(0);
}

void Rmpc_get_default_prec2(void) {
     dTHX;
     dXSARGS;
     dMY_CXT;
     EXTEND(SP, 2);
     ST(0) = sv_2mortal(newSVuv(DEFAULT_PREC_RE));
     ST(1) = sv_2mortal(newSVuv(DEFAULT_PREC_IM));
     XSRETURN(2);
}

void Rmpc_set_prec(pTHX_ mpc_t * p, SV * prec) {
     mpc_set_prec(*p, SvUV(prec));
}

void Rmpc_set_re_prec(pTHX_ mpc_t * p, SV * prec) {
     mpfr_set_prec(MPC_RE(*p), SvUV(prec));
}

void Rmpc_set_im_prec(pTHX_ mpc_t * p, SV * prec) {
     mpfr_set_prec(MPC_IM(*p), SvUV(prec));
}

SV * Rmpc_get_prec(pTHX_ mpc_t * x) {
     return newSVuv(mpc_get_prec(*x));
}

void Rmpc_get_prec2(pTHX_ mpc_t * x) {
     dXSARGS;
     mp_prec_t re, im;
     mpc_get_prec2(&re, &im, *x);
     /* sp = mark; *//* not needed */
     EXTEND(SP, 2);
     ST(0) = sv_2mortal(newSVuv(re));
     ST(1) = sv_2mortal(newSVuv(im));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

SV * Rmpc_get_im_prec(pTHX_ mpc_t * x) {
     return newSVuv(mpfr_get_prec(MPC_IM(*x)));
}

SV * Rmpc_get_re_prec(pTHX_ mpc_t * x) {
     return newSVuv(mpfr_get_prec(MPC_RE(*x)));
}

void RMPC_RE(mpfr_t * fr, mpc_t * x) {
     mp_prec_t precision = mpfr_get_prec(MPC_RE(*x));
     mpfr_set_prec(*fr, precision);
     mpfr_set(*fr, MPC_RE(*x), GMP_RNDN); /* No rounding will be done, anyway */
}

void RMPC_IM(mpfr_t * fr, mpc_t * x) {
     mp_prec_t precision = mpfr_get_prec(MPC_IM(*x));
     mpfr_set_prec(*fr, precision);
     mpfr_set(*fr, MPC_IM(*x), GMP_RNDN); /* No rounding will be done, anyway */
}

SV * RMPC_INEX_RE(pTHX_ SV * x) {
     return newSViv(MPC_INEX_RE(SvIV(x)));
}

SV * RMPC_INEX_IM(pTHX_ SV * x) {
     return newSViv(MPC_INEX_IM(SvIV(x)));
}

void DESTROY(pTHX_ mpc_t * p) {
     mpc_clear(*p);
     Safefree(p);
}

void Rmpc_clear(pTHX_ mpc_t * p) {
     mpc_clear(*p);
     Safefree(p);
}

void Rmpc_clear_mpc(mpc_t * p) {
     mpc_clear(*p);
}

void Rmpc_clear_ptr(pTHX_ mpc_t * p) {
     Safefree(p);
}

SV * Rmpc_init2(pTHX_ SV * prec) {
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in Rmpc_init2 function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init2 (*mpc_t_obj, SvUV(prec));

     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpc_init3(pTHX_ SV * prec_r, SV * prec_i) {
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in Rmpc_init3 function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3 (*mpc_t_obj, SvUV(prec_r), SvUV(prec_i));

     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpc_init2_nobless(pTHX_ SV * prec) {
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in Rmpc_init2_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     mpc_init2 (*mpc_t_obj, SvUV(prec));

     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpc_init3_nobless(pTHX_ SV * prec_r, SV * prec_i) {
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in Rmpc_init3_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     mpc_init3 (*mpc_t_obj, SvUV(prec_r), SvUV(prec_i));

     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpc_set(pTHX_ mpc_t * p, mpc_t * q, SV * round) {
     return newSViv(mpc_set(*p, *q, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_ui(pTHX_ mpc_t * p, SV * q, SV * round) {
     return newSViv(mpc_set_ui(*p, SvUV(q), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_si(pTHX_ mpc_t * p, SV * q, SV * round) {
     return newSViv(mpc_set_si(*p, SvIV(q), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_ld(pTHX_ mpc_t * p, SV * q, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     return newSViv(mpc_set_ld(*p, SvNV(q), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_NV(pTHX_ mpc_t * p, SV * q, unsigned int round) {
#if defined(MPC_CAN_PASS_FLOAT128)
     int ret;
     mpfr_t f128;

     if(!SvNOK(q)) croak("Second arg given to Rmpc_set_NV is not an NV");

     mpfr_init2(f128, FLT128_MANT_DIG);
     mpfr_set_float128(f128, SvNVX(q), MPC_RNDNN);
     ret = mpc_set_fr(*p, f128, (mpc_rnd_t)round);
     mpfr_clear(f128);
     return newSViv(ret);

#elif defined(NV_IS_FLOAT128)

     char * buffer;
     int exp, exp2 = 0;
     float128 ld, buffer_size;
     mpfr_t t;
     int returned;

     if(!SvNOK(q)) croak("Second arg given to Rmpc_set_NV is not an NV");

     ld = (float128)SvNVX(q);
     mpfr_init2(t, FLT128_MANT_DIG);
     if(ld != ld) {
       mpc_set_fr(*p, t, MPC_RNDNN);
       mpfr_clear(t);
       return newSViv(0);
     }

     if(ld != 0.0Q && (ld / ld != 1)) {
       returned = ld > 0.0Q ? 1 : -1;
       mpfr_set_inf(t, returned);
       mpc_set_fr(*p, t, MPC_RNDNN);
       mpfr_clear(t);
       return newSViv(0);
     }

     ld = frexpq((float128)SvNVX(q), &exp);

     while(ld != floorq(ld)) {
          ld *= 2;
          exp2 += 1;
     }

     buffer_size = ld < 0.0Q ? ld * -1.0Q : ld;
     buffer_size = ceilq(logq(buffer_size + 1) / 2.30258509299404568401799145468436418Q);

     Newxz(buffer, buffer_size + 5, char);
     if(buffer == NULL) croak("Failed to allocate memory in Rmpc_set_NV");

     returned = quadmath_snprintf(buffer, (size_t)buffer_size + 5, "%.0Qf", ld);
     if(returned < 0) croak("In Rmpc_set_NV, encoding error in quadmath_snprintf function");
     if(returned >= buffer_size + 5) croak("In Rmpc_set_NV, buffer given to quadmath_snprintf function was too small");
     mpfr_set_str(t, buffer, 10, MPC_RNDNN); /* exact */
     Safefree(buffer);

     if (exp2 > exp) mpfr_div_2ui(t, t, exp2 - exp, GMP_RNDN);
     else mpfr_mul_2ui(t, t, exp - exp2, GMP_RNDN);
     returned = mpc_set_fr(*p, t, (mpc_rnd_t)round);
     mpfr_clear(t);
     return newSViv(returned);


#elif defined(NV_IS_LONG_DOUBLE)

     if(!SvNOK(q)) croak("Second arg given to Rmpc_set_NV is not an NV");
     return newSViv(mpc_set_ld(*p, SvNVX(q), (mpc_rnd_t)round));

#else

     if(!SvNOK(q)) croak("Second arg given to Rmpc_set_NV is not an NV");
     return newSViv(mpc_set_d(*p, SvNVX(q), (mpc_rnd_t)round));

#endif
}

SV * Rmpc_set_NV_NV(pTHX_ mpc_t * p, SV * re_q, SV * im_q, SV * round) {
#if defined(MPC_CAN_PASS_FLOAT128)

     int ret;
     mpfr_t re_f128, im_f128;

     if(!SvNOK(re_q) || !SvNOK(im_q)) croak("Second and/or third arg given to Rmpc_set_NV_NV is not an NV");

     mpfr_init2(re_f128, FLT128_MANT_DIG);
     mpfr_init2(im_f128, FLT128_MANT_DIG);
     mpfr_set_float128(re_f128, SvNVX(re_q), ((mpc_rnd_t)SvUV(round)) & 3);
     mpfr_set_float128(im_f128, SvNVX(im_q), ((mpc_rnd_t)SvUV(round)) / 16);
     ret = mpc_set_fr_fr(*p, re_f128, im_f128, (mpc_rnd_t)SvUV(round));
     mpfr_clear(re_f128);
     mpfr_clear(im_f128);
     return newSViv(ret);

#elif defined(NV_IS_FLOAT128)

     char * buffer;
     int exp, exp2 = 0, done_re = 0, done_im = 0;
     float128 re_ld, im_ld, buffer_size;
     mpfr_t re_fr, im_fr;
     int returned;

     if(!SvNOK(re_q) || !SvNOK(im_q)) croak("Second and/or third arg given to Rmpc_set_NV_NV is not an NV");

     re_ld = (float128)SvNVX(re_q);
     im_ld = (float128)SvNVX(im_q);
     mpfr_init2(re_fr, FLT128_MANT_DIG);
     mpfr_init2(im_fr, FLT128_MANT_DIG);

/************** real part ****************/

     if(re_ld != re_ld) {
       mpfr_set_nan(re_fr);
       done_re = 1;
     }

     if(!done_re) {
       if(re_ld != 0.0Q && (re_ld / re_ld != 1)) {
         returned = re_ld > 0.0Q ? 1 : -1;
         mpfr_set_inf(re_fr, returned);
         done_re = 1;
       }

       if(!done_re) {
         re_ld = frexpq(re_ld, &exp);

         while(re_ld != floorq(re_ld)) {
           re_ld *= 2;
           exp2 += 1;
         }

         buffer_size = re_ld < 0.0Q ? re_ld * -1.0Q : re_ld;
         buffer_size = ceilq(logq(buffer_size + 1) / 2.30258509299404568401799145468436418Q);

         Newxz(buffer, buffer_size + 5, char);
         if(buffer == NULL) croak("Failed to allocate memory in Rmpc_set_NV_NV");

         returned = quadmath_snprintf(buffer, (size_t)buffer_size + 5, "%.0Qf", re_ld);
         if(returned < 0) croak("In Rmpc_set_NV_NV, encoding error in quadmath_snprintf function");
         if(returned >= buffer_size + 5) croak("In Rmpc_set_NV_NV, buffer given to quadmath_snprintf function was too small");
         mpfr_set_str(re_fr, buffer, 10, (mp_rnd_t)round); /* exact */
         Safefree(buffer);

         if (exp2 > exp) mpfr_div_2ui(re_fr, re_fr, exp2 - exp, GMP_RNDN);
         else mpfr_mul_2ui(re_fr, re_fr, exp - exp2, GMP_RNDN);
       }
     }

/************** imag part ****************/

     if(im_ld != im_ld) {
       mpfr_set_nan(im_fr);
       done_im = 1;
     }

     if(!done_im) {
       if(im_ld != 0.0Q && (im_ld / im_ld != 1)) {
         returned = im_ld > 0.0Q ? 1 : -1;
         mpfr_set_inf(im_fr, returned);
         done_im = 1;
       }

       if(!done_im) {
         im_ld = frexpq(im_ld, &exp);

         while(im_ld != floorq(im_ld)) {
           im_ld *= 2;
           exp2 += 1;
         }

         buffer_size = im_ld < 0.0Q ? im_ld * -1.0Q : im_ld;
         buffer_size = ceilq(logq(buffer_size + 1) / 2.30258509299404568401799145468436418Q);

         Newxz(buffer, buffer_size + 5, char);
         if(buffer == NULL) croak("Failed to allocate memory in Rmpc_set_NV_NV");

         returned = quadmath_snprintf(buffer, (size_t)buffer_size + 5, "%.0Qf", im_ld);
         if(returned < 0) croak("In Rmpc_set_NV_NV, encoding error in quadmath_snprintf function");
         if(returned >= buffer_size + 5) croak("In Rmpc_set_NV_NV, buffer given to quadmath_snprintf function was too small");
         mpfr_set_str(im_fr, buffer, 10, (mp_rnd_t)round); /* exact */
         Safefree(buffer);

         if (exp2 > exp) mpfr_div_2ui(im_fr, im_fr, exp2 - exp, GMP_RNDN);
         else mpfr_mul_2ui(im_fr, im_fr, exp - exp2, GMP_RNDN);
       }
     }

     returned = mpc_set_fr_fr(*p, re_fr, im_fr, MPC_RNDNN);
     mpfr_clear(re_fr);
     mpfr_clear(im_fr);
     return newSViv(returned);

#elif defined(NV_IS_LONG_DOUBLE)

     if(!SvNOK(re_q) || !SvNOK(im_q)) croak("Second and/or third arg given to Rmpc_set_NV_NV is not an NV");
     return newSViv(mpc_set_ld_ld(*p, SvNVX(re_q), SvNVX(im_q), (mpc_rnd_t)SvUV(round)));

#else

     if(!SvNOK(re_q) || !SvNOK(im_q)) croak("Second and/or third arg given to Rmpc_set_NV_NV is not an NV");
     return newSViv(mpc_set_d_d(*p, SvNVX(re_q), SvNVX(im_q), (mpc_rnd_t)SvUV(round)));
#endif
}

SV * Rmpc_set_uj(pTHX_ mpc_t * p, SV * q, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     return newSViv(mpc_set_uj(*p, SvUV(q), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_uj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj(pTHX_ mpc_t * p, SV * q, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     return newSViv(mpc_set_sj(*p, SvIV(q), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_z(pTHX_ mpc_t * p, mpz_t * q, SV * round) {
     return newSViv(mpc_set_z(*p, *q, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_f(pTHX_ mpc_t * p, mpf_t * q, SV * round) {
     return newSViv(mpc_set_f(*p, *q, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_q(pTHX_ mpc_t * p, mpq_t * q, SV * round) {
     return newSViv(mpc_set_q(*p, *q, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_d(pTHX_ mpc_t * p, SV * q, SV * round) {
     return newSViv(mpc_set_d(*p, SvNV(q), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_fr(pTHX_ mpc_t * p, mpfr_t * q, SV * round) {
     return newSViv(mpc_set_fr(*p, *q, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_ui_ui(pTHX_ mpc_t * p, SV * q_r, SV * q_i, SV * round) {
     return newSViv(mpc_set_ui_ui(*p, (unsigned long)SvUV(q_r), (unsigned long)SvUV(q_i), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_si_si(pTHX_ mpc_t * p, SV * q_r, SV * q_i, SV * round) {
     return newSViv(mpc_set_si_si(*p, (long)SvIV(q_r), (long)SvIV(q_i), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_d_d(pTHX_ mpc_t * p, SV * q_r, SV * q_i, SV * round) {
     return newSViv(mpc_set_d_d(*p, (double)SvNV(q_r), (double)SvNV(q_i), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_ld_ld(pTHX_ mpc_t * mpc, SV * ld1, SV * ld2, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     return newSViv(mpc_set_ld_ld(*mpc, SvNV(ld1), SvNV(ld2), (mpc_rnd_t) SvUV(round)));
#else
     croak("Rmpc_set_ld_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_z_z(pTHX_ mpc_t * p, mpz_t * q_r, mpz_t * q_i, SV * round) {
     return newSViv(mpc_set_z_z(*p, *q_r, *q_i, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_q_q(pTHX_ mpc_t * p, mpq_t * q_r, mpq_t * q_i, SV * round) {
     return newSViv(mpc_set_q_q(*p, *q_r, *q_i, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_f_f(pTHX_ mpc_t * p, mpf_t * q_r, mpf_t * q_i, SV * round) {
     return newSViv(mpc_set_f_f(*p, *q_r, *q_i, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_fr_fr(pTHX_ mpc_t * p, mpfr_t * q_r, mpfr_t * q_i, SV * round) {
     return newSViv(mpc_set_fr_fr(*p, *q_r, *q_i, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_set_d_ui(pTHX_ mpc_t * mpc, SV * d, SV * ui, SV * round) {
     SV_MPC_SET_X_Y(d, ui, *mpc, (double)SvNV(d), (unsigned long int)SvUV(ui), (mpc_rnd_t)SvUV(round));
}

SV * Rmpc_set_d_si(pTHX_ mpc_t * mpc, SV * d, SV * si, SV * round) {
     SV_MPC_SET_X_Y(d, si, *mpc, (double)SvNV(d), (signed long int)SvIV(si), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_d_fr(pTHX_ mpc_t * mpc, SV * d, mpfr_t * mpfr, SV * round) {
     SV_MPC_SET_X_Y(d, fr, *mpc, (double)SvNV(d), *mpfr, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_ui_d(pTHX_ mpc_t * mpc, SV * ui, SV * d, SV * round) {
     SV_MPC_SET_X_Y(ui, d, *mpc, (unsigned long)SvUV(ui), (double)SvNV(d), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_ui_si(pTHX_ mpc_t * mpc, SV * ui, SV * si, SV * round) {
     SV_MPC_SET_X_Y(ui, si, *mpc, (unsigned long)SvUV(ui), (signed long int)SvIV(si), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_ui_fr(pTHX_ mpc_t * mpc, SV * ui, mpfr_t * mpfr, SV * round) {
     SV_MPC_SET_X_Y(ui, fr, *mpc, (unsigned long)SvUV(ui), *mpfr, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_si_d(pTHX_ mpc_t * mpc, SV * si, SV * d, SV * round) {
     SV_MPC_SET_X_Y(si, d, *mpc, (signed long int)SvIV(si), (double)SvNV(d), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_si_ui(pTHX_ mpc_t * mpc, SV * si, SV * ui, SV * round) {
     SV_MPC_SET_X_Y(si, ui, *mpc, (signed long int)SvIV(si), (unsigned long)SvUV(ui), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_si_fr(pTHX_ mpc_t * mpc, SV * si, mpfr_t * mpfr, SV * round) {
     SV_MPC_SET_X_Y(si, fr, *mpc, (signed long int)SvIV(si), *mpfr, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_fr_d(pTHX_ mpc_t * mpc, mpfr_t * mpfr, SV * d, SV * round) {
     SV_MPC_SET_X_Y(fr, d, *mpc, *mpfr, (double)SvNV(d), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_fr_ui(pTHX_ mpc_t * mpc, mpfr_t * mpfr, SV * ui, SV * round) {
     SV_MPC_SET_X_Y(fr, ui, *mpc, *mpfr, (unsigned long)SvUV(ui), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_fr_si(pTHX_ mpc_t * mpc, mpfr_t * mpfr, SV * si, SV * round) {
     SV_MPC_SET_X_Y(fr, si, *mpc, *mpfr , (signed long int)SvIV(si), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_ld_ui(pTHX_ mpc_t * mpc, SV * d, SV * ui, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ld, ui, *mpc, SvNV(d), (unsigned long)SvUV(ui), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ld_ui not implemented for this build of perl");
#endif
}

SV * Rmpc_set_ld_si(pTHX_ mpc_t * mpc, SV * d, SV * si, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ld, si, *mpc, SvNV(d), (signed long int)SvIV(si), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ld_si not implemented for this build of perl");
#endif
}

SV * Rmpc_set_ld_fr(pTHX_ mpc_t * mpc, SV * d, mpfr_t * mpfr, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ld, fr, *mpc, SvNV(d), *mpfr, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ld_fr not implemented for this build of perl");
#endif
}

SV * Rmpc_set_ui_ld(pTHX_ mpc_t * mpc, SV * ui, SV * d, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ui, ld, *mpc, (unsigned long)SvUV(ui), SvNV(d), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ui_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_si_ld(pTHX_ mpc_t * mpc, SV * si, SV * d, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(si, ld, *mpc, (signed long int)SvIV(si), SvNV(d), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_si_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_fr_ld(pTHX_ mpc_t * mpc, mpfr_t * mpfr, SV * d, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(fr, ld, *mpc, *mpfr, SvNV(d), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_fr_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_d_uj(pTHX_ mpc_t * mpc, SV * d, SV * ui, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(d, uj, *mpc, (double)SvNV(d), SvUV(ui), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_d_uj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_d_sj(pTHX_ mpc_t * mpc, SV * d, SV * si, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(d, sj, *mpc, (double)SvNV(d), SvIV(si), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_d_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj_d(pTHX_ mpc_t * mpc, SV * si, SV * d, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(sj, d, *mpc, SvIV(si), (double)SvNV(d), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_sj_d not implemented for this build of perl");
#endif
}

SV * Rmpc_set_uj_d(pTHX_ mpc_t * mpc, SV * ui, SV * d, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(uj, d, *mpc, SvUV(ui), (double)SvNV(d), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_uj_d not implemented for this build of perl");
#endif
}

SV * Rmpc_set_uj_fr(pTHX_ mpc_t * mpc, SV * ui, mpfr_t * mpfr, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(uj, fr, *mpc, SvUV(ui), *mpfr, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_uj_fr not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj_fr(pTHX_ mpc_t * mpc, SV * si, mpfr_t * mpfr, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(sj, fr, *mpc, SvIV(si), *mpfr, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_sj_fr not implemented for this build of perl");
#endif
}

SV * Rmpc_set_fr_uj(pTHX_ mpc_t * mpc, mpfr_t * mpfr, SV * ui, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(fr, uj, *mpc, *mpfr, SvUV(ui), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_fr_uj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_fr_sj(pTHX_ mpc_t * mpc, mpfr_t * mpfr, SV * si, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(fr, sj, *mpc, *mpfr , SvIV(si), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_fr_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_uj_sj(pTHX_ mpc_t * mpc, SV * ui, SV * si, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(uj, sj, *mpc, SvUV(ui), SvIV(si), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_uj_si, Rmpc_set_ui_sj and Rmpc_set_uj_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj_uj(pTHX_ mpc_t * mpc, SV * si, SV * ui, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(sj, uj, *mpc, SvIV(si), SvUV(ui), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_sj_ui, Rmpc_set_si_uj and Rmpc_set_sj_uj not implemented for this build of perl");
#endif
}


SV * Rmpc_set_ld_uj(pTHX_ mpc_t * mpc, SV * d, SV * ui, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ld, uj, *mpc, SvNV(d), SvUV(ui), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ld_uj not implemented for this build of perl");
#endif
#else
     croak("Rmpc_set_ld_uj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_ld_sj(pTHX_ mpc_t * mpc, SV * d, SV * si, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ld, sj, *mpc, SvNV(d), SvIV(si), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ld_sj not implemented for this build of perl");
#endif
#else
     croak("Rmpc_set_ld_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_uj_ld(pTHX_ mpc_t * mpc, SV * ui, SV * d, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(uj, ld, *mpc, SvUV(ui), SvNV(d), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_uj_ld not implemented for this build of perl");
#endif
#else
     croak("Rmpc_set_uj_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj_ld(pTHX_ mpc_t * mpc, SV * si, SV * d, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(sj, ld, *mpc, SvIV(si), SvNV(d), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_sj_ld not implemented for this build of perl");
#endif
#else
     croak("Rmpc_set_sj_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_f_ui(pTHX_ mpc_t * mpc, mpf_t * mpf, SV * ui, SV * round) {
     SV_MPC_SET_X_Y(f, ui, *mpc, *mpf, (unsigned long int)SvUV(ui), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_q_ui(pTHX_ mpc_t * mpc, mpq_t * mpq, SV * ui, SV * round) {
     SV_MPC_SET_X_Y(q, ui, *mpc, *mpq, (unsigned long int)SvUV(ui), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_z_ui(pTHX_ mpc_t * mpc, mpz_t * mpz, SV * ui, SV * round) {
     SV_MPC_SET_X_Y(z, ui, *mpc, *mpz, (unsigned long int)SvUV(ui), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_f_si(pTHX_ mpc_t * mpc, mpf_t * mpf, SV * si, SV * round) {
     SV_MPC_SET_X_Y(f, si, *mpc, *mpf, (signed long int)SvIV(si), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_q_si(pTHX_ mpc_t * mpc, mpq_t * mpq, SV * si, SV * round) {
     SV_MPC_SET_X_Y(q, si, *mpc, *mpq, (signed long int)SvIV(si), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_z_si(pTHX_ mpc_t * mpc, mpz_t * mpz, SV * si, SV * round) {
     SV_MPC_SET_X_Y(z, si, *mpc, *mpz, (signed long int)SvIV(si), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_f_d(pTHX_ mpc_t * mpc, mpf_t * mpf, SV * d, SV * round) {
     SV_MPC_SET_X_Y(f, d, *mpc, *mpf, (double)SvNV(d), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_q_d(pTHX_ mpc_t * mpc, mpq_t * mpq, SV * d, SV * round) {
     SV_MPC_SET_X_Y(q, d, *mpc, *mpq, (double)SvNV(d), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_z_d(pTHX_ mpc_t * mpc, mpz_t * mpz, SV * d, SV * round) {
     SV_MPC_SET_X_Y(z, d, *mpc, *mpz, (double)SvNV(d), (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_f_uj(pTHX_ mpc_t * mpc, mpf_t * mpf, SV * uj, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(f, uj, *mpc, *mpf, (unsigned long long)SvUV(uj), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_f_uj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_q_uj(pTHX_ mpc_t * mpc, mpq_t * mpq, SV * uj, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(q, uj, *mpc, *mpq, (unsigned long long)SvUV(uj), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_q_uj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_z_uj(pTHX_ mpc_t * mpc, mpz_t * mpz, SV * uj, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(z, uj, *mpc, *mpz, (unsigned long long)SvUV(uj), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_z_uj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_f_sj(pTHX_ mpc_t * mpc, mpf_t * mpf, SV * sj, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(f, sj, *mpc, *mpf, (signed long long)SvIV(sj), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_f_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_q_sj(pTHX_ mpc_t * mpc, mpq_t * mpq, SV * sj, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(q, sj, *mpc, *mpq, (signed long long)SvIV(sj), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_q_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_z_sj(pTHX_ mpc_t * mpc, mpz_t * mpz, SV * sj, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(z, sj, *mpc, *mpz, (signed long long)SvIV(sj), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_z_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_f_ld(pTHX_ mpc_t * mpc, mpf_t * mpf, SV * ld, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(f, ld, *mpc, *mpf, (long double)SvNV(ld), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_f_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_q_ld(pTHX_ mpc_t * mpc, mpq_t * mpq, SV * ld, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(q, ld, *mpc, *mpq, (long double)SvNV(ld), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_q_ld not implemented for this build of perl");
#endif
}

SV * Rmpc_set_z_ld(pTHX_ mpc_t * mpc, mpz_t * mpz, SV * ld, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(z, ld, *mpc, *mpz, (long double)SvNV(ld), (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_z_ld not implemented for this build of perl");
#endif
}

/*
##############################
##############################
*/

SV * Rmpc_set_ui_f(pTHX_ mpc_t * mpc, SV * ui, mpf_t * mpf, SV * round) {
     SV_MPC_SET_X_Y(ui, f, *mpc, (unsigned long int)SvUV(ui), *mpf, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_ui_q(pTHX_ mpc_t * mpc, SV * ui, mpq_t * mpq, SV * round) {
     SV_MPC_SET_X_Y(ui, q, *mpc, (unsigned long int)SvUV(ui), *mpq, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_ui_z(pTHX_ mpc_t * mpc, SV * ui, mpz_t * mpz, SV * round) {
     SV_MPC_SET_X_Y(ui, z, *mpc, (unsigned long int)SvUV(ui), *mpz, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_si_f(pTHX_ mpc_t * mpc, SV * si, mpf_t * mpf, SV * round) {
     SV_MPC_SET_X_Y(si, f, *mpc, (signed long int)SvIV(si), *mpf, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_si_q(pTHX_ mpc_t * mpc, SV * si, mpq_t * mpq, SV * round) {
     SV_MPC_SET_X_Y(si, q, *mpc, (signed long int)SvIV(si), *mpq, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_si_z(pTHX_ mpc_t * mpc, SV * si, mpz_t * mpz, SV * round) {
     SV_MPC_SET_X_Y(si, z, *mpc, (signed long int)SvIV(si), *mpz, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_d_f(pTHX_ mpc_t * mpc, SV * d, mpf_t * mpf, SV * round) {
     SV_MPC_SET_X_Y(d, f, *mpc, (double)SvNV(d), *mpf, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_d_q(pTHX_ mpc_t * mpc, SV * d, mpq_t * mpq, SV * round) {
     SV_MPC_SET_X_Y(d, q, *mpc, (double)SvNV(d), *mpq, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_d_z(pTHX_ mpc_t * mpc, SV * d, mpz_t * mpz, SV * round) {
     SV_MPC_SET_X_Y(d, z, *mpc, (double)SvNV(d), *mpz, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_uj_f(pTHX_ mpc_t * mpc, SV * uj, mpf_t * mpf, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(uj, f, *mpc, (unsigned long long)SvUV(uj), *mpf, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_uj_f not implemented for this build of perl");
#endif
}

SV * Rmpc_set_uj_q(pTHX_ mpc_t * mpc, SV * uj, mpq_t * mpq, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(uj, q, *mpc, (unsigned long long)SvUV(uj), *mpq, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_uj_q not implemented for this build of perl");
#endif
}

SV * Rmpc_set_uj_z(pTHX_ mpc_t * mpc, SV * uj, mpz_t * mpz, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(uj, z, *mpc, (unsigned long long)SvUV(uj), *mpz, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_uj_z not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj_f(pTHX_ mpc_t * mpc, SV * sj, mpf_t * mpf, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(sj, f, *mpc, (signed long long)SvIV(sj), *mpf, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_sj_f not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj_q(pTHX_ mpc_t * mpc, SV * sj, mpq_t * mpq, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(sj, q, *mpc, (signed long long)SvIV(sj), *mpq, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_sj_q not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj_z(pTHX_ mpc_t * mpc, SV * sj, mpz_t * mpz, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     SV_MPC_SET_X_Y(sj, z, *mpc, (signed long long)SvIV(sj), *mpz, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_sj_z not implemented for this build of perl");
#endif
}

SV * Rmpc_set_ld_f(pTHX_ mpc_t * mpc, SV * ld, mpf_t * mpf, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ld, f, *mpc, (long double)SvNV(ld), *mpf, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ld_f not implemented for this build of perl");
#endif
}

SV * Rmpc_set_ld_q(pTHX_ mpc_t * mpc, SV * ld, mpq_t * mpq, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ld, q, *mpc, (long double)SvNV(ld), *mpq, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ld_q not implemented for this build of perl");
#endif
}

SV * Rmpc_set_ld_z(pTHX_ mpc_t * mpc, SV * ld, mpz_t * mpz, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     SV_MPC_SET_X_Y(ld, z, *mpc, (long double)SvNV(ld), *mpz, (mpc_rnd_t) SvUV(round));
#else
     croak("Rmpc_set_ld_z not implemented for this build of perl");
#endif
}

/*
##############################
##############################
*/

SV * Rmpc_set_f_q(pTHX_ mpc_t * mpc, mpf_t * mpf, mpq_t * mpq, SV * round) {
     SV_MPC_SET_X_Y(f, q, *mpc, *mpf, *mpq, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_q_f(pTHX_ mpc_t * mpc, mpq_t * mpq, mpf_t * mpf, SV * round) {
     SV_MPC_SET_X_Y(q, f, *mpc, *mpq, *mpf, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_f_z(pTHX_ mpc_t * mpc, mpf_t * mpf, mpz_t * mpz, SV * round) {
     SV_MPC_SET_X_Y(f, z, *mpc, *mpf, *mpz, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_z_f(pTHX_ mpc_t * mpc, mpz_t * mpz, mpf_t * mpf, SV * round) {
     SV_MPC_SET_X_Y(z, f, *mpc, *mpz, *mpf, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_q_z(pTHX_ mpc_t * mpc, mpq_t * mpq, mpz_t * mpz, SV * round) {
     SV_MPC_SET_X_Y(q, z, *mpc, *mpq, *mpz, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_z_q(pTHX_ mpc_t * mpc, mpz_t * mpz, mpq_t * mpq, SV * round) {
     SV_MPC_SET_X_Y(z, q, *mpc, *mpz, *mpq, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_f_fr(pTHX_ mpc_t * mpc, mpf_t * mpf, mpfr_t * mpfr, SV * round) {
     SV_MPC_SET_X_Y(f, fr, *mpc, *mpf, *mpfr, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_fr_f(pTHX_ mpc_t * mpc, mpfr_t * mpfr, mpf_t * mpf, SV * round) {
     SV_MPC_SET_X_Y(fr, f, *mpc, *mpfr, *mpf, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_q_fr(pTHX_ mpc_t * mpc, mpq_t * mpq, mpfr_t * mpfr, SV * round) {
     SV_MPC_SET_X_Y(q, fr, *mpc, *mpq, *mpfr, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_fr_q(pTHX_ mpc_t * mpc, mpfr_t * mpfr, mpq_t * mpq, SV * round) {
     SV_MPC_SET_X_Y(fr, q, *mpc, *mpfr, *mpq, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_z_fr(pTHX_ mpc_t * mpc, mpz_t * mpz, mpfr_t * mpfr, SV * round) {
     SV_MPC_SET_X_Y(z, fr, *mpc, *mpz, *mpfr, (mpc_rnd_t) SvUV(round));
}

SV * Rmpc_set_fr_z(pTHX_ mpc_t * mpc, mpfr_t * mpfr, mpz_t * mpz, SV * round) {
     SV_MPC_SET_X_Y(fr, z, *mpc, *mpfr, *mpz, (mpc_rnd_t) SvUV(round));
}


/*
##############################
##############################
*/

SV * Rmpc_set_uj_uj(pTHX_ mpc_t * mpc, SV * uj1, SV * uj2, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     return newSViv(mpc_set_uj_uj(*mpc, (unsigned long long)SvUV(uj1),
                    (unsigned long long)SvUV(uj2), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_ui_uj, Rmpc_set_uj_ui and Rmpc_set_uj_uj not implemented for this build of perl");
#endif
}

SV * Rmpc_set_sj_sj(pTHX_ mpc_t * mpc, SV * sj1, SV * sj2, SV * round) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
     return newSViv(mpc_set_sj_sj(*mpc, (signed long long)SvIV(sj1),
                    (signed long long)SvIV(sj2), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_si_sj, Rmpc_set_sj_si and Rmpc_set_sj_sj not implemented for this build of perl");
#endif
}

SV * Rmpc_add(pTHX_ mpc_t * a, mpc_t * b, mpc_t * c, SV * round) {
     return newSViv(mpc_add(*a, *b, *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_add_ui(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round){
     return newSViv(mpc_add_ui(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_add_fr(pTHX_ mpc_t * a, mpc_t * b, mpfr_t * c, SV * round){
     return newSViv(mpc_add_fr(*a, *b, *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_sub(pTHX_ mpc_t * a, mpc_t * b, mpc_t * c, SV * round) {
     return newSViv(mpc_sub(*a, *b, *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_sub_ui(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round) {
     return newSViv(mpc_sub_ui(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_ui_sub(pTHX_ mpc_t * a, SV * b, mpc_t * c, SV * round) {
     return newSViv(mpc_ui_sub(*a, SvUV(b), *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_ui_ui_sub(pTHX_ mpc_t * a, SV * b_r, SV * b_i, mpc_t * c, SV * round) {
     return newSViv(mpc_ui_ui_sub(*a, SvUV(b_r), SvUV(b_i), *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_mul(pTHX_ mpc_t * a, mpc_t * b, mpc_t * c, SV * round) {
     return newSViv(mpc_mul(*a, *b, *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_mul_ui(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round){
     return newSViv(mpc_mul_ui(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_mul_si(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round){
     return newSViv(mpc_mul_si(*a, *b, SvIV(c), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_mul_fr(pTHX_ mpc_t * a, mpc_t * b, mpfr_t * c, SV * round){
     return newSViv(mpc_mul_fr(*a, *b, *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_mul_i(pTHX_ mpc_t * a, mpc_t * b, SV * sign, SV * round){
     return newSViv(mpc_mul_i(*a, *b, SvIV(sign), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_sqr(pTHX_ mpc_t * a, mpc_t * b, SV * round) {
     return newSViv(mpc_sqr(*a, *b, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_div(pTHX_ mpc_t * a, mpc_t * b, mpc_t * c, SV * round) {
     return newSViv(mpc_div(*a, *b, *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_div_ui(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round){
     return newSViv(mpc_div_ui(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_ui_div(pTHX_ mpc_t * a, SV * b, mpc_t * c, SV * round) {
     return newSViv(mpc_ui_div(*a, SvUV(b), *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_div_fr(pTHX_ mpc_t * a, mpc_t * b, mpfr_t * c, SV * round){
     return newSViv(mpc_div_fr(*a, *b, *c, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_sqrt(pTHX_ mpc_t * a, mpc_t * b, SV * round) {
     return newSViv(mpc_sqrt(*a, *b, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_pow(pTHX_ mpc_t * a, mpc_t * b, mpc_t * pow, SV * round) {
     return newSViv(mpc_pow(*a, *b, *pow, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_pow_d(pTHX_ mpc_t * a, mpc_t * b, SV * pow, SV * round) {
     return newSViv(mpc_pow_d(*a, *b, SvNV(pow), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_pow_ld(pTHX_ mpc_t * a, mpc_t * b, SV * pow, SV * round) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
     return newSViv(mpc_pow_ld(*a, *b, SvNV(pow), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_pow_ld not implemented on this build of perl");
#endif
}

SV * Rmpc_pow_si(pTHX_ mpc_t * a, mpc_t * b, SV * pow, SV * round) {
     return newSViv(mpc_pow_si(*a, *b, SvIV(pow), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_pow_ui(pTHX_ mpc_t * a, mpc_t * b, SV * pow, SV * round) {
     return newSViv(mpc_pow_ui(*a, *b, SvUV(pow), (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_pow_z(pTHX_ mpc_t * a, mpc_t * b, mpz_t * pow, SV * round) {
     return newSViv(mpc_pow_z(*a, *b, *pow, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_pow_fr(pTHX_ mpc_t * a, mpc_t * b, mpfr_t * pow, SV * round) {
     return newSViv(mpc_pow_fr(*a, *b, *pow, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_neg(pTHX_ mpc_t * a, mpc_t * b, SV * round) {
     return newSViv(mpc_neg(*a, *b, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_abs(pTHX_ mpfr_t * a, mpc_t * b, SV * round) {
     return newSViv(mpc_abs(*a, *b, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_conj(pTHX_ mpc_t * a, mpc_t * b, SV * round) {
     return newSViv(mpc_conj(*a, *b, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_norm(pTHX_ mpfr_t * a, mpc_t * b, SV * round) {
     return newSViv(mpc_norm(*a, *b, (mpc_rnd_t)SvUV(round)));
}

/* Beginning mpc-1.0, mpc_mul_2exp and mpc_div_2exp were
*  renamed mpc_mul_2ui and mpc_div_2ui
*/

SV * Rmpc_mul_2ui(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round) {
#if MPC_VERSION < 65536
     return newSViv(mpc_mul_2exp(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
#else
     return newSViv(mpc_mul_2ui(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
#endif
}

SV * Rmpc_div_2ui(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round) {
#if MPC_VERSION < 65536
     return newSViv(mpc_div_2exp(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
#else
     return newSViv(mpc_div_2ui(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
#endif
}

SV * Rmpc_cmp(pTHX_ mpc_t * a, mpc_t * b) {
     return newSViv(mpc_cmp(*a, *b));
}

SV * Rmpc_cmp_si(pTHX_ mpc_t * a, SV * b) {
     return newSViv(mpc_cmp_si(*a, SvIV(b)));
}

SV * Rmpc_cmp_si_si(pTHX_ mpc_t * a, SV * b, SV * c) {
     return newSViv(mpc_cmp_si_si(*a, SvIV(b), SvIV(c)));
}

SV * Rmpc_exp(pTHX_ mpc_t * a, mpc_t * b, SV * round) {
     return newSViv(mpc_exp(*a, *b, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_log(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_log(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * _Rmpc_out_str(pTHX_ FILE * stream, SV * base, SV * dig, mpc_t * p, SV * round) {
     size_t ret;
     if(SvIV(base) < 2 || SvIV(base) > 36) croak("2nd argument supplied to Rmpc_out_str is out of allowable range (must be between 2 and 36 inclusive)");
     ret = mpc_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpc_rnd_t)SvUV(round));
     fflush(stream);
     return newSVuv(ret);
}

SV * _Rmpc_out_strS(pTHX_ FILE * stream, SV * base, SV * dig, mpc_t * p, SV * round, SV * suff) {
     size_t ret;
     if(SvIV(base) < 2 || SvIV(base) > 36) croak("2nd argument supplied to Rmpc_out_str is out of allowable range (must be between 2 and 36 inclusive)");
     ret = mpc_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpc_rnd_t)SvUV(round));
     fflush(stream);
     fprintf(stream, "%s", SvPV_nolen(suff));
     fflush(stream);
     return newSVuv(ret);
}

SV * _Rmpc_out_strP(pTHX_ SV * pre, FILE * stream, SV * base, SV * dig, mpc_t * p, SV * round) {
     size_t ret;
     if(SvIV(base) < 2 || SvIV(base) > 36) croak("3rd argument supplied to Rmpc_out_str is out of allowable range (must be between 2 and 36 inclusive)");
     fprintf(stream, "%s", SvPV_nolen(pre));
     fflush(stream);
     ret = mpc_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpc_rnd_t)SvUV(round));
     fflush(stream);
     return newSVuv(ret);
}

SV * _Rmpc_out_strPS(pTHX_ SV * pre, FILE * stream, SV * base, SV * dig, mpc_t * p, SV * round, SV * suff) {
     size_t ret;
     if(SvIV(base) < 2 || SvIV(base) > 36) croak("3rd argument supplied to Rmpc_out_str is out of allowable range (must be between 2 and 36 inclusive)");
     fprintf(stream, "%s", SvPV_nolen(pre));
     fflush(stream);
     ret = mpc_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpc_rnd_t)SvUV(round));
     fflush(stream);
     fprintf(stream, "%s", SvPV_nolen(suff));
     fflush(stream);
     return newSVuv(ret);
}


int  Rmpc_inp_str(pTHX_ mpc_t * p, FILE * stream, SV * base, SV * round) {
     int ret;
     if(SvIV(base) < 2 || SvIV(base) > 36) croak("3rd argument supplied to Rmpc_inp_str is out of allowable range (must be between 2 and 36 inclusive)");
     ret = mpc_inp_str(*p, stream, NULL, (int)SvIV(base), (mpc_rnd_t)SvUV(round));
     if(ret == -1) croak("Invalid string given to Rmpc_inp_str");
     return ret;
}

/* Removed in mpc-0.7
void Rmpc_random(mpc_t * p) {
     mpc_random(*p);
}
*/

/* Removed in mpc-0.7
void Rmpc_random2(mpc_t * p, SV * s, SV * exp) {
     mpc_random2(*p, SvIV(s), SvUV(exp));
}
*/

SV * Rmpc_sin(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_sin(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_cos(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_cos(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_tan(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_tan(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_sinh(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_sinh(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_cosh(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_cosh(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_tanh(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_tanh(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_asin(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_asin(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_acos(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_acos(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_atan(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_atan(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_asinh(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_asinh(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_acosh(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_acosh(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_atanh(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_atanh(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * overload_true(pTHX_ mpc_t *a, SV *second, SV * third) {
     if(
       ( mpfr_nan_p(MPC_RE(*a)) || !mpfr_cmp_ui(MPC_RE(*a), 0) ) &&
       ( mpfr_nan_p(MPC_IM(*a)) || !mpfr_cmp_ui(MPC_IM(*a), 0) )
       ) return newSVuv(0);
     return newSVuv(1);
}

/********************************/
/********************************/
/********************************/
/********************************/
/********************************/
/********************************/
/********************************/
/********************************/

SV * overload_mul(pTHX_ mpc_t * a, SV * b, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;
     mpfr_t t;
     int ret;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_mul function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPC_NEED_LONG_LONG_INT

     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER

       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUVX(b), GMP_RNDN);
#endif
       mpc_mul_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER

       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIVX(b), GMP_RNDN);

#endif
       mpc_mul_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

#else
     if(SvUOK(b)) {
       mpc_mul_ui(*mpc_t_obj, *a, SvUVX(b), DEFAULT_ROUNDING_MODE);
       return obj_ref;
       }

     if(SvIOK(b)) {
       mpc_mul_si(*mpc_t_obj, *a, SvIVX(b), DEFAULT_ROUNDING_MODE);
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       mpc_mul_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvPOK(b)) { /* assign the string with default precision */

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_mul");}

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(*mpc_t_obj, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(*mpc_t_obj, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
           croak("Invalid string (%s) supplied to Math::MPC::overload_mul", SvPV_nolen(b));
       }
#else
       if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
         croak("Invalid string (%s) supplied to Math::MPC::overload_mul", SvPV_nolen(b));
#endif
       mpc_mul(*mpc_t_obj, *a, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_mul(*mpc_t_obj, *a, *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return obj_ref;
         }
       }

     croak("Invalid argument supplied to Math::MPC::overload_mul");
}

SV * overload_add(pTHX_ mpc_t* a, SV * b, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;
     mpfr_t t;
     int ret;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_add function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPC_NEED_LONG_LONG_INT

     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER

       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUVX(b), GMP_RNDN);
#endif
       mpc_add_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER

       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIVX(b), GMP_RNDN);

#endif
       mpc_add_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

#else
     if(SvUOK(b)) {
       mpc_add_ui(*mpc_t_obj, *a, SvUVX(b), DEFAULT_ROUNDING_MODE);
       return obj_ref;
       }

     if(SvIOK(b)) {
       if(SvIVX(b) >= 0)
         mpc_add_ui(*mpc_t_obj, *a, SvUVX(b)     , DEFAULT_ROUNDING_MODE);
       else
         mpc_sub_ui(*mpc_t_obj, *a, SvIVX(b) * -1, DEFAULT_ROUNDING_MODE);
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       mpc_add_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvPOK(b)) { /* assign string with default precision */

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_add");}

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(*mpc_t_obj, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(*mpc_t_obj, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
           croak("Invalid string (%s) supplied to Math::MPC::overload_add", SvPV_nolen(b));
       }
#else
       if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
         croak("Invalid string (%s) supplied to Math::MPC::overload_add", SvPV_nolen(b));
#endif
       mpc_add(*mpc_t_obj, *a, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_add(*mpc_t_obj, *a, *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return obj_ref;
         }
       }

     croak("Invalid argument supplied to Math::MPC::overload_add");
}

SV * overload_sub(pTHX_ mpc_t * a, SV * b, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;
     mpfr_t t;
     int ret;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_sub function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPC_NEED_LONG_LONG_INT

     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER

       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUVX(b), GMP_RNDN);
#endif
       if(third == &PL_sv_yes) mpc_fr_sub(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else mpc_sub_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER

       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIVX(b), GMP_RNDN);

#endif
       if(third == &PL_sv_yes) mpc_fr_sub(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else mpc_sub_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

#else
     if(SvUOK(b)) {
       if(third == &PL_sv_yes) mpc_ui_sub(*mpc_t_obj, SvUVX(b), *a, DEFAULT_ROUNDING_MODE);
       else mpc_sub_ui(*mpc_t_obj, *a, SvUVX(b), DEFAULT_ROUNDING_MODE);
       return obj_ref;
       }

     if(SvIOK(b)) {
       if(third == &PL_sv_yes) {
          if(SvIVX(b) >=0) {
            mpc_ui_sub(*mpc_t_obj, SvUVX(b), *a, DEFAULT_ROUNDING_MODE);
          }
          else {
            mpc_add_ui(*mpc_t_obj, *a, SvIVX(b) * -1, DEFAULT_ROUNDING_MODE);
            mpc_neg(*mpc_t_obj, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
          }
       }
       else {
          if(SvIVX(b) >=0)
            mpc_sub_ui(*mpc_t_obj, *a, SvUVX(b), DEFAULT_ROUNDING_MODE);
          else
            mpc_add_ui(*mpc_t_obj, *a, SvIVX(b) * -1, DEFAULT_ROUNDING_MODE);
       }
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       if(third == &PL_sv_yes) mpc_fr_sub(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else mpc_sub_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvPOK(b)) { /* assign with default precision */

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_sub");}

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(*mpc_t_obj, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(*mpc_t_obj, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
           croak("Invalid string (%s) supplied to Math::MPC::overload_sub", SvPV_nolen(b));
       }
#else
       if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
         croak("Invalid string (%s) supplied to Math::MPC::overload_sub", SvPV_nolen(b));
#endif
       if(third == &PL_sv_yes) mpc_sub(*mpc_t_obj, *mpc_t_obj, *a, DEFAULT_ROUNDING_MODE);
       else mpc_sub(*mpc_t_obj, *a, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
       return obj_ref;
       }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_sub(*mpc_t_obj, *a, *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return obj_ref;
         }
       }

     croak("Invalid argument supplied to Math::MPC::overload_sub function");
}

SV * overload_div(pTHX_ mpc_t * a, SV * b, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;
     mpfr_t t;
     int ret;


     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_div function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPC_NEED_LONG_LONG_INT

     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER

       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUVX(b), GMP_RNDN);
#endif
       if(third == &PL_sv_yes) mpc_fr_div(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else mpc_div_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER

       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIVX(b), GMP_RNDN);

#endif
       if(third == &PL_sv_yes) mpc_fr_div(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else mpc_div_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

#else
     if(SvUOK(b)) {
       if(third == &PL_sv_yes) mpc_ui_div(*mpc_t_obj, SvUVX(b), *a, DEFAULT_ROUNDING_MODE);
       else mpc_div_ui(*mpc_t_obj, *a, SvUVX(b), DEFAULT_ROUNDING_MODE);
       return obj_ref;
       }

     if(SvIOK(b)) {
       if(third == &PL_sv_yes) {
          if(SvIVX(b) >=0) {
            mpc_ui_div(*mpc_t_obj, SvUVX(b), *a, DEFAULT_ROUNDING_MODE);
          }
          else {
            mpc_ui_div(*mpc_t_obj, SvIVX(b) * -1, *a, DEFAULT_ROUNDING_MODE);
            mpc_neg(*mpc_t_obj, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
          }
       }
       else {
          if(SvIVX(b) >=0) {
            mpc_div_ui(*mpc_t_obj, *a, SvUVX(b), DEFAULT_ROUNDING_MODE);
          }
          else {
            mpc_div_ui(*mpc_t_obj, *a, SvIVX(b) * -1, DEFAULT_ROUNDING_MODE);
            mpc_neg(*mpc_t_obj, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
          }
       }
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       if(third == &PL_sv_yes) mpc_fr_div(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else mpc_div_fr(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvPOK(b)) { /* assign with default precision */

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_div");}

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(*mpc_t_obj, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(*mpc_t_obj, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
           croak("Invalid string (%s) supplied to Math::MPC::overload_div", SvPV_nolen(b));
       }
#else
       if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
         croak("Invalid string (%s) supplied to Math::MPC::overload_div", SvPV_nolen(b));
#endif
       if(third == &PL_sv_yes) mpc_div(*mpc_t_obj, *mpc_t_obj, *a, DEFAULT_ROUNDING_MODE);
       else mpc_div(*mpc_t_obj, *a, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
       return obj_ref;
       }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_div(*mpc_t_obj, *a, *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return obj_ref;
         }
       }

     croak("Invalid argument supplied to Math::MPC::overload_div function");

}


SV * overload_div_eq(pTHX_ SV * a, SV * b, SV * third) {
     dMY_CXT;
     mpfr_t t;
     mpc_t temp;
     int ret;

     SvREFCNT_inc(a);

#ifdef MATH_MPC_NEED_LONG_LONG_INT
     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUVX(b), GMP_RNDN);
#endif
       mpc_div_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIVX(b), GMP_RNDN);
#endif
       mpc_div_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvUOK(b)) {
       mpc_div_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvUVX(b), DEFAULT_ROUNDING_MODE);
       return a;
     }

     if(SvIOK(b)) {
       if(SvIV(b) >= 0) {
         mpc_div_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvUVX(b), DEFAULT_ROUNDING_MODE);
         return a;
       }
       mpc_div_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvIVX(b) * -1, DEFAULT_ROUNDING_MODE);
       mpc_neg(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), DEFAULT_ROUNDING_MODE);
       return a;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       mpc_div_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_div_eq");}

       mpc_init3(temp, DEFAULT_PREC);  /* cannot assign to an mpfr_t - may have an imaginary component */

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
           SvREFCNT_dec(a);
           croak("Invalid string (%s) supplied to Math::MPC::overload_div_eq", SvPV_nolen(b));
         }
       }
#else
       if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
         SvREFCNT_dec(a);
         croak("Invalid string (%s) supplied to Math::MPC::overload_div_eq", SvPV_nolen(b));
       }
#endif
       mpc_div(*(INT2PTR(mpc_t *, SvIV(SvRV(a)))), *(INT2PTR(mpc_t *, SvIV(SvRV(a)))), temp, DEFAULT_ROUNDING_MODE);
       mpc_clear(temp);
       return a;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_div(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPC::overload_div_eq function");

}

SV * overload_sub_eq(pTHX_ SV * a, SV * b, SV * third) {
     dMY_CXT;
     mpfr_t t;
     mpc_t temp;
     int ret;

     SvREFCNT_inc(a);

#ifdef MATH_MPC_NEED_LONG_LONG_INT
     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUVX(b), GMP_RNDN);
#endif
       mpc_sub_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIVX(b), GMP_RNDN);
#endif
       mpc_sub_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvUOK(b)) {
       mpc_sub_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvUVX(b), DEFAULT_ROUNDING_MODE);
       return a;
     }

     if(SvIOK(b)) {
       if(SvIV(b) >= 0) {
         mpc_sub_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvUVX(b), DEFAULT_ROUNDING_MODE);
         return a;
       }
       mpc_add_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvIVX(b) * -1, DEFAULT_ROUNDING_MODE);
       return a;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       mpc_sub_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_sub_eq");}

       mpc_init3(temp, DEFAULT_PREC); /* cannot assign to an mpfr_t - may have an imaginary component */

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
           SvREFCNT_dec(a);
           croak("Invalid string (%s) supplied to Math::MPC::overload_sub_eq", SvPV_nolen(b));
         }
       }
#else

       if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
         SvREFCNT_dec(a);
         croak("Invalid string (%s) supplied to Math::MPC::overload_sub_eq", SvPV_nolen(b));
       }
#endif
       mpc_sub(*(INT2PTR(mpc_t *, SvIV(SvRV(a)))), *(INT2PTR(mpc_t *, SvIV(SvRV(a)))), temp, DEFAULT_ROUNDING_MODE);
       mpc_clear(temp);
       return a;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_sub(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPC::overload_sub_eq function");

}

SV * overload_add_eq(pTHX_ SV * a, SV * b, SV * third) {
     dMY_CXT;
     SvREFCNT_inc(a);
     mpfr_t t;
     mpc_t temp;
     int ret;

#ifdef MATH_MPC_NEED_LONG_LONG_INT
     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUV(b), GMP_RNDN);
#endif
       mpc_add_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
 #ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIV(b), GMP_RNDN);
#endif
       mpc_add_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvUOK(b)) {
       mpc_add_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvUVX(b), DEFAULT_ROUNDING_MODE);
       return a;
     }

     if(SvIOK(b)) {
       if(SvIV(b) >= 0) {
         mpc_add_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvUVX(b), DEFAULT_ROUNDING_MODE);
         return a;
       }
       mpc_sub_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvIVX(b) * -1, DEFAULT_ROUNDING_MODE);
       return a;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
      _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       mpc_add_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_add_eq");}

       mpc_init3(temp, DEFAULT_PREC); /* cannot assign to an mpfr_t - may contain an imaginary part */

#ifdef _WIN32_BIZARRE_INFNAN
      ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
           SvREFCNT_dec(a);
           croak("Invalid string (1: %s) supplied to Math::MPC::overload_add_eq", SvPV_nolen(b));
         }
       }
#else
       if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
         SvREFCNT_dec(a);
         croak("Invalid string (2: %s) supplied to Math::MPC::overload_add_eq", SvPV_nolen(b));
       }
#endif
       mpc_add(*(INT2PTR(mpc_t *, SvIV(SvRV(a)))), *(INT2PTR(mpc_t *, SvIV(SvRV(a)))), temp, DEFAULT_ROUNDING_MODE);
       mpc_clear(temp);
       return a;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_add(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPC::overload_add_eq");
}

SV * overload_mul_eq(pTHX_ SV * a, SV * b, SV * third) {
     dMY_CXT;
     mpfr_t t;
     mpc_t temp;
     int ret;

     SvREFCNT_inc(a);

#ifdef MATH_MPC_NEED_LONG_LONG_INT
     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUVX(b), GMP_RNDN);
#endif
       mpc_mul_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIVX(b), GMP_RNDN);
#endif
       mpc_mul_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvUOK(b)) {
       mpc_mul_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvUVX(b), DEFAULT_ROUNDING_MODE);
       return a;
     }

     if(SvIOK(b)) {
       mpc_mul_si(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvIVX(b), DEFAULT_ROUNDING_MODE);
       return a;
     }

#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       mpc_mul_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_mul_eq");}

       mpc_init3(temp, DEFAULT_PREC); /* cannot assign to an mpfr_t - may contain an imaginary part */

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
           SvREFCNT_dec(a);
           croak("Invalid string (%s) supplied to Math::MPC::overload_mul_eq", SvPV_nolen(b));
         }
       }
#else
       if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
         SvREFCNT_dec(a);
         croak("Invalid string (%s) supplied to Math::MPC::overload_mul_eq", SvPV_nolen(b));
       }
#endif
       mpc_mul(*(INT2PTR(mpc_t *, SvIV(SvRV(a)))), *(INT2PTR(mpc_t *, SvIV(SvRV(a)))), temp, DEFAULT_ROUNDING_MODE);
       mpc_clear(temp);
       return a;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_mul(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPC::overload_mul_eq");
}

SV * overload_pow(pTHX_ mpc_t * a, SV * b, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj, t;
     SV * obj_ref, * obj;
     mpfr_t temp;
     int ret;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_pow function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPC_NEED_LONG_LONG_INT

     if(SvUOK(b)) {
       mpc_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER
       mpc_set_str(t, SvPV_nolen(b), 10, MPC_RNDNN);
#else
       mpc_set_uj(t, SvUVX(b), MPC_RNDNN);
#endif
       if(third == &PL_sv_yes)
         mpc_pow(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else
         mpc_pow(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpc_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpc_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER
       mpc_set_str(t, SvPV_nolen(b), 10, MPC_RNDNN);
#else
       mpc_set_sj(t, SvIV(b), MPC_RNDNN);
#endif
       if(third == &PL_sv_yes)
         mpc_pow(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else
         mpc_pow(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpc_clear(t);
       return obj_ref;
     }

#else
     if(SvUOK(b)) {
       mpc_init2(t, sizeof(UV) * CHAR_BIT);
       mpc_set_ui(t, SvUVX(b), MPC_RNDNN);
       if(third == &PL_sv_yes)
         mpc_pow(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else
         mpc_pow(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpc_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpc_init2(t, sizeof(IV) * CHAR_BIT);
       mpc_set_si(t, SvIVX(b), MPC_RNDNN);
       if(third == &PL_sv_yes)
         mpc_pow(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else
         mpc_pow(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpc_clear(t);
       return obj_ref;
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpc_init2(t, FLT128_MANT_DIG);
       Rmpc_set_NV(aTHX_ &t, b, MPC_RNDNN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpc_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpc_set_ld(t, (long double)SvNVX(b), MPC_RNDNN);
#else
       mpc_init2(t, DBL_MANT_DIG);
       mpc_set_d(t, (double)SvNVX(b), MPC_RNDNN);
#endif
       if(third == &PL_sv_yes)
         mpc_pow(*mpc_t_obj, t, *a, DEFAULT_ROUNDING_MODE);
       else
         mpc_pow(*mpc_t_obj, *a, t, DEFAULT_ROUNDING_MODE);
       mpc_clear(t);
       return obj_ref;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_pow");}

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(temp);
         if(ret == 2) {
           mpfr_set_nan(temp);
           mpc_set_fr(*mpc_t_obj, temp, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(temp, ret);
           mpc_set_fr(*mpc_t_obj, temp, MPC_RNDNN);
         }
         mpfr_clear(temp);
       }
       else {
         if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
           croak("Invalid string (%s) supplied to Math::MPC::overload_pow", SvPV_nolen(b));
       }
#else
       if(mpc_set_str(*mpc_t_obj, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
         croak("Invalid string (%s) supplied to Math::MPC::overload_pow", SvPV_nolen(b));
#endif
       if(third == &PL_sv_yes)
         mpc_pow(*mpc_t_obj, *mpc_t_obj, *a, DEFAULT_ROUNDING_MODE);
       else
         mpc_pow(*mpc_t_obj, *a, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_pow(*mpc_t_obj, *a, *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPC::overload_pow");
}

SV * overload_pow_eq(pTHX_ SV * a, SV * b, SV * third) {
     dMY_CXT;
     mpfr_t t;
     mpc_t temp;
     int ret;


     SvREFCNT_inc(a);

#ifdef MATH_MPC_NEED_LONG_LONG_INT
     if(SvUOK(b)) {
       mpfr_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_uj(t, SvUVX(b), GMP_RNDN);
#endif
       mpc_pow_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER
       mpfr_set_str(t, SvPV_nolen(b), 10, GMP_RNDN);
#else
       mpfr_set_sj(t, SvIVX(b), GMP_RNDN);
#endif
       mpc_pow_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvUOK(b)) {
       mpc_pow_ui(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvUVX(b), DEFAULT_ROUNDING_MODE);
       return a;
     }

     if(SvIOK(b)) {
       mpc_pow_si(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), SvIVX(b), DEFAULT_ROUNDING_MODE);
       return a;
     }

#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       _mpfr_set_NV(aTHX_ &t, b, GMP_RNDN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNVX(b), GMP_RNDN);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNVX(b), GMP_RNDN);
#endif
       mpc_pow_fr(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), t, DEFAULT_ROUNDING_MODE);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_pow_eq");}

       mpc_init3(temp, DEFAULT_PREC); /* cannot assign to an mpfr_t - may contain an imaginary part */

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         mpfr_init(t);
         if(ret == 2) {
           mpfr_set_nan(t);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         else {
           mpfr_set_inf(t, ret);
           mpc_set_fr(temp, t, MPC_RNDNN);
         }
         mpfr_clear(t);
       }
       else {
         if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
           SvREFCNT_dec(a);
           croak("Invalid string (%s) supplied to Math::MPC::overload_mul_eq", SvPV_nolen(b));
         }
       }
#else
       if(mpc_set_str(temp, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1) {
         SvREFCNT_dec(a);
         croak("Invalid string (%s) supplied to Math::MPC::overload_pow_eq", SvPV_nolen(b));
       }
#endif
       mpc_pow(*(INT2PTR(mpc_t *, SvIV(SvRV(a)))), *(INT2PTR(mpc_t *, SvIV(SvRV(a)))), temp, DEFAULT_ROUNDING_MODE);
       mpc_clear(temp);
       return a;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         mpc_pow(*(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPC::overload_pow_eq");
}

SV * overload_equiv(pTHX_ mpc_t * a, SV * b, SV * third) {
     dMY_CXT;
     mpfr_t temp;
     mpc_t t;
     int ret;

     if(mpfr_nan_p(MPC_RE(*a)) || mpfr_nan_p(MPC_IM(*a))) return newSViv(0);

#ifdef MATH_MPC_NEED_LONG_LONG_INT
     if(SvUOK(b)) {
       mpc_init2(t, sizeof(UV) * CHAR_BIT);
#ifdef _MSC_VER
       mpc_set_str(t, SvPV_nolen(b), 10, MPC_RNDNN);
#else
       mpc_set_uj(t, SvUVX(b), MPC_RNDNN);
#endif
       ret = mpc_cmp(*a, t);
       mpc_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       mpc_init2(t, sizeof(IV) * CHAR_BIT);
#ifdef _MSC_VER
       mpc_set_str(t, SvPV_nolen(b), 10, MPC_RNDNN);
#else
       mpc_set_sj(t, SvIVX(b), MPC_RNDNN);
#endif
       ret = mpc_cmp(*a, t);
       mpc_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }
#else
     if(SvUOK(b)) {
       mpc_init2(t, sizeof(UV) * CHAR_BIT);
       mpc_set_ui(t, SvUVX(b), MPC_RNDNN);
       ret = mpc_cmp(*a, t);
       mpc_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       ret = mpc_cmp_si(*a, SvIVX(b));
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }
#endif

     if(SvNOK(b) && !SvPOK(b)) { /* do not use the NV if POK is set */
#if defined(NV_IS_FLOAT128)
       mpc_init2(t, FLT128_MANT_DIG);
       Rmpc_set_NV(aTHX_ &t, b, MPC_RNDNN);

#elif defined(NV_IS_LONG_DOUBLE)
       mpc_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpc_set_ld(t, (long double)SvNVX(b), MPC_RNDNN);
#else
       mpc_init2(t, DBL_MANT_DIG);
       mpc_set_d(t, (double)SvNVX(b), MPC_RNDNN);
#endif
       if(mpfr_nan_p(MPC_RE(t)) || mpfr_nan_p(MPC_IM(t))) {
         mpc_clear(t);
         return newSViv(0);
       }
       ret = mpc_cmp(*a, t);
       mpc_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {

       NOK_POK_DUALVAR_CHECK , "Math::MPC::overload_equiv");}

#ifdef _WIN32_BIZARRE_INFNAN
       ret = _win32_infnanstring(SvPV_nolen(b));
       if(ret) {
         if(ret == 2) return newSViv(0);
         else {
           mpc_init3(t, DEFAULT_PREC);
           mpfr_init(temp);
           mpfr_set_inf(temp, ret);
           mpc_set_fr(t, temp, MPC_RNDNN);
           mpfr_clear(temp);
         }
       }
       else {
         mpc_init3(t, DEFAULT_PREC);
         if(mpc_set_str(t, (char *)SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
           croak("Invalid string (%s) supplied to Math::MPC::overload_equiv", SvPV_nolen(b));
       }
#else
       mpc_init3(t, DEFAULT_PREC);
       if(mpc_set_str(t, (char *)SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE) == -1)
         croak("Invalid string (%s) supplied to Math::MPC::overload_equiv", SvPV_nolen(b));
#endif
       if(mpfr_nan_p(MPC_RE(t)) || mpfr_nan_p(MPC_IM(t))) {
         mpc_clear(t);
         return newSViv(0);
       }
       ret = mpc_cmp(*a, t);
       mpc_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPC")) {
         if(mpfr_nan_p(MPC_RE(*(INT2PTR(mpc_t *, SvIVX(SvRV(b)))))) ||
            mpfr_nan_p(MPC_IM(*(INT2PTR(mpc_t *, SvIVX(SvRV(b))))))) return newSViv(0);
         ret = mpc_cmp(*a, *(INT2PTR(mpc_t *, SvIVX(SvRV(b)))));
         if(ret == 0) return newSViv(1);
         return newSViv(0);
       }
     }

     croak("Invalid argument supplied to Math::MPC::overload_equiv");
}

SV * overload_not(pTHX_ mpc_t * a, SV * second, SV * third) {
     if(mpfr_nan_p(MPC_RE(*a)) || mpfr_nan_p(MPC_IM(*a))) return newSViv(1); /* Thanks Jean-Louis Morel */
     if(mpc_cmp_si_si(*a, 0, 0)) return newSViv(0);
     return newSViv(1);
}

SV * overload_sqrt(pTHX_ mpc_t * p, SV * second, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_sqrt function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);

     mpc_sqrt(*mpc_t_obj, *p, DEFAULT_ROUNDING_MODE);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

void overload_copy(pTHX_ mpc_t * p, SV * second, SV * third) {
     dXSARGS;
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;
     mp_prec_t re, im;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_copy function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");

     mpc_get_prec2(&re, &im, *p);
     mpc_init3(*mpc_t_obj, re, im);
     mpc_set(*mpc_t_obj, *p, DEFAULT_ROUNDING_MODE);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     /* PUTBACK; *//* not needed */
     XSRETURN(1);
}

SV * overload_abs(pTHX_ mpc_t * p, SV * second, SV * third) {
     dMY_CXT;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     New(1, mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_abs function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpc_abs(*mpfr_t_obj, *p, DEFAULT_ROUNDING_MODE);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_exp(pTHX_ mpc_t * p, SV * second, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_exp function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);

     mpc_exp(*mpc_t_obj, *p, DEFAULT_ROUNDING_MODE);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_log(pTHX_ mpc_t * p, SV * second, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_exp function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);

     mpc_log(*mpc_t_obj, *p, DEFAULT_ROUNDING_MODE);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_sin(pTHX_ mpc_t * p, SV * second, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_sin function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);

     mpc_sin(*mpc_t_obj, *p, DEFAULT_ROUNDING_MODE);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_cos(pTHX_ mpc_t * p, SV * second, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_sin function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);

     mpc_cos(*mpc_t_obj, *p, DEFAULT_ROUNDING_MODE);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

void _get_r_string(pTHX_ mpc_t * p, SV * base, SV * n_digits, SV * round) {
     dXSARGS;
     char * out;
     mp_exp_t ptr;
     unsigned long b = SvUV(base);

     if(b < 2 || b > 36) croak("Second argument supplied to r_string is not in acceptable range");

     out = mpfr_get_str(0, &ptr, b, SvUV(n_digits), MPC_RE(*p), (mpc_rnd_t)SvUV(round) & 3);

     if(out == NULL) croak("An error occurred in _get_r_string");

     /* sp = mark; *//* not needed */
     ST(0) = sv_2mortal(newSVpv(out, 0));
     mpfr_free_str(out);
     ST(1) = sv_2mortal(newSViv(ptr));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void _get_i_string(pTHX_ mpc_t * p, SV * base, SV * n_digits, SV * round) {
     dXSARGS;
     char * out;
     mp_exp_t ptr;
     unsigned long b = SvUV(base);

     if(b < 2 || b > 36) croak("Second argument supplied to i_string is not in acceptable range");

     out = mpfr_get_str(0, &ptr, b, SvUV(n_digits), MPC_IM(*p), (mpc_rnd_t)SvUV(round) & 3);

     if(out == NULL) croak("An error occurred in _get_i_string");

     /* sp = mark; *//* not needed */
     ST(0) = sv_2mortal(newSVpv(out, 0));
     mpfr_free_str(out);
     ST(1) = sv_2mortal(newSViv(ptr));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}


/* ########################################
   ########################################
   ########################################
   ########################################
   ########################################
   ######################################## */



SV * _itsa(pTHX_ SV * a) {
     if(SvUOK(a)) return newSVuv(1);
     if(SvIOK(a)) return newSVuv(2);
     if(SvNOK(a) && !SvPOK(a)) return newSVuv(3);
     if(SvPOK(a)) return newSVuv(4);
     if(sv_isobject(a)) {
       const char *h = HvNAME(SvSTASH(SvRV(a)));
       if(strEQ(h, "Math::MPFR")) return newSVuv(5);
       if(strEQ(h, "Math::GMPf")) return newSVuv(6);
       if(strEQ(h, "Math::GMPq")) return newSVuv(7);
       if(strEQ(h, "Math::GMPz")) return newSVuv(8);
       if(strEQ(h, "Math::GMP")) return newSVuv(9);
       if(strEQ(h, "Math::MPC")) return newSVuv(10);
       }
     return newSVuv(0);
}

SV * _new_real_im(pTHX_ SV * b, SV * d) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     mpfr_t temp_re, temp_im;
     int done_re = 0, done_im = 0;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in _new_real_im function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);

     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);

     mpfr_init2(temp_re, DEFAULT_PREC_RE);
     mpfr_init2(temp_im, DEFAULT_PREC_IM);

#ifdef MATH_MPC_NEED_LONG_LONG_INT

     if(SvUOK(b) && !done_re) {
#ifdef _MSC_VER
       mpfr_set_str(temp_re, SvPV_nolen(b), 10, DEFAULT_ROUNDING_MODE & 3);
#else
       mpfr_set_uj(temp_re, SvUVX(b), DEFAULT_ROUNDING_MODE & 3);
#endif
       done_re = 1;
     }

     if(SvIOK(b) && !done_re) {
#ifdef _MSC_VER
       mpfr_set_str(temp_re, SvPV_nolen(b), 10, DEFAULT_ROUNDING_MODE & 3);
#else
       mpfr_set_sj(temp_re, SvIVX(b), DEFAULT_ROUNDING_MODE & 3);
#endif
       done_re = 1;
     }

#else
     if(SvUOK(b) && !done_re) {
       mpfr_set_ui(temp_re, SvUVX(b), DEFAULT_ROUNDING_MODE & 3);
       done_re = 1;
     }

     if(SvIOK(b) && !done_re) {
       mpfr_set_si(temp_re, SvIVX(b), DEFAULT_ROUNDING_MODE & 3);
       done_re = 1;
     }
#endif

     if(SvNOK(b) && !done_re && !SvPOK(b)) {
#if defined(MPC_CAN_PASS_FLOAT128)
       mpfr_set_float128(temp_re, SvNVX(b), DEFAULT_ROUNDING_MODE & 3);
#elif defined(NV_IS_FLOAT128)
       _mpfr_set_NV(aTHX_ &temp_re, b, GMP_RNDN);
#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_set_ld(temp_re, SvNVX(b), DEFAULT_ROUNDING_MODE & 3);
#else
       mpfr_set_d(temp_re, SvNVX(b), DEFAULT_ROUNDING_MODE & 3);
#endif
       done_re = 1;
     }

     if(SvPOK(b) && !done_re) {

       NOK_POK_DUALVAR_CHECK , "Math::MPC::new");}

#ifdef _WIN32_BIZARRE_INFNAN
       done_re = _win32_infnanstring(SvPV_nolen(b));
       if(done_re) {
         if(done_re == 2) mpfr_set_nan(temp_re);
         else mpfr_set_inf(temp_re, done_re);
       }
       else {
         if(mpfr_set_str(temp_re, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE & 3) == -1)
           croak("Invalid real string (%s) supplied to Math::MPC::new", SvPV_nolen(b));
       }
#else
       if(mpfr_set_str(temp_re, SvPV_nolen(b), 0, DEFAULT_ROUNDING_MODE & 3) == -1)
         croak("Invalid real string (%s) supplied to Math::MPC::new", SvPV_nolen(b));
#endif
       done_re = 1;
     }

     if(sv_isobject(b) && !done_re) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::MPFR")) {
         mpfr_set(temp_re, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE & 3);
         done_re = 1;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_set_f(temp_re, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE & 3);
         done_re = 1;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_set_q(temp_re, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE & 3);
         done_re = 1;
       }
       if(strEQ(h, "Math::GMP") ||
          strEQ(h, "Math::GMPz"))  {
         mpfr_set_z(temp_re, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), DEFAULT_ROUNDING_MODE & 3);
         done_re = 1;
       }
     }

     if(!done_re)
       croak("Invalid real argument supplied to Math::MPC::new");

/****************************************************************/

#ifdef MATH_MPC_NEED_LONG_LONG_INT

     if(SvUOK(d) && !done_im) {
#ifdef _MSC_VER
       mpfr_set_str(temp_im, SvPV_nolen(d), 10, DEFAULT_ROUNDING_MODE / 16);
#else
       mpfr_set_uj(temp_im, SvUVX(d), DEFAULT_ROUNDING_MODE / 16);
#endif
       done_im = 1;
     }

     if(SvIOK(d) && !done_im) {
#ifdef _MSC_VER
       mpfr_set_str(temp_im, SvPV_nolen(d), 10, DEFAULT_ROUNDING_MODE / 16);
#else
       mpfr_set_sj(temp_im, SvIVX(d), DEFAULT_ROUNDING_MODE / 16);
#endif
       done_im = 1;
     }

#else
     if(SvUOK(d) && !done_im) {
       mpfr_set_ui(temp_im, SvUVX(d), DEFAULT_ROUNDING_MODE / 16);
       done_im = 1;
     }

     if(SvIOK(d) && !done_im) {
       mpfr_set_si(temp_im, SvIVX(d), DEFAULT_ROUNDING_MODE / 16);
       done_im = 1;
     }
#endif

     if(SvNOK(d) && !done_im && !SvPOK(d)) {

#if defined(MPC_CAN_PASS_FLOAT128)
       mpfr_set_float128(temp_im, SvNVX(d), DEFAULT_ROUNDING_MODE / 16);
#elif defined(NV_IS_FLOAT128)
       _mpfr_set_NV(aTHX_ &temp_im, d, GMP_RNDN);
#elif defined(NV_IS_LONG_DOUBLE)
       mpfr_set_ld(temp_im, SvNVX(d), DEFAULT_ROUNDING_MODE / 16);
#else
       mpfr_set_d(temp_im, SvNVX(d), DEFAULT_ROUNDING_MODE / 16);
#endif
       done_im = 1;
     }

     if(SvPOK(d) && !done_im) {

       if(SvNOK(d)) {
         nok_pok++;
         if(SvIV(get_sv("Math::MPC::NOK_POK", 0)))
           warn("Scalar passed to %s is both NV and PV. Using PV (string) value", "Math::MPC::new");}

#ifdef _WIN32_BIZARRE_INFNAN
       done_im = _win32_infnanstring(SvPV_nolen(d));
       if(done_im) {
         if(done_im == 2) mpfr_set_nan(temp_im);
         else mpfr_set_inf(temp_im, done_im);
       }
       else {
         if(mpfr_set_str(temp_im, SvPV_nolen(d), 0, DEFAULT_ROUNDING_MODE & 3) == -1)
           croak("Invalid imaginary string (%s) supplied to Math::MPC::new", SvPV_nolen(d));
       }
#else
       if(mpfr_set_str(temp_im, SvPV_nolen(d), 0, DEFAULT_ROUNDING_MODE & 3) == -1)
         croak("Invalid imaginary string (%s) supplied to Math::MPC::new", SvPV_nolen(d));
#endif
       done_im = 1;
     }

     if(sv_isobject(d) && !done_im) {
       const char *h = HvNAME(SvSTASH(SvRV(d)));
       if(strEQ(h, "Math::MPFR")) {
         mpfr_set(temp_im, *(INT2PTR(mpfr_t *, SvIVX(SvRV(d)))), DEFAULT_ROUNDING_MODE / 16);
         done_im = 1;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_set_f(temp_im, *(INT2PTR(mpf_t *, SvIVX(SvRV(d)))), DEFAULT_ROUNDING_MODE / 16);
         done_im = 1;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_set_q(temp_im, *(INT2PTR(mpq_t *, SvIVX(SvRV(d)))), DEFAULT_ROUNDING_MODE / 16);
         done_im = 1;
       }
       if(strEQ(h, "Math::GMP") ||
          strEQ(h, "Math::GMPz"))  {
         mpfr_set_z(temp_im, *(INT2PTR(mpz_t *, SvIVX(SvRV(d)))), DEFAULT_ROUNDING_MODE / 16);
         done_im = 1;
       }
     }

     if(!done_im)
       croak("Invalid imaginary argument supplied to Math::MPC::new");

/****************************************************************/

     mpc_set_fr_fr(*mpc_t_obj, temp_re, temp_im, DEFAULT_ROUNDING_MODE);
     mpfr_clear(temp_re);
     mpfr_clear(temp_im);
     return obj_ref;
}

int _has_longlong(void) {
#ifdef MATH_MPC_NEED_LONG_LONG_INT
    return 1;
#else
    return 0;
#endif
}

int _has_longdouble(void) {
#if defined(NV_IS_LONG_DOUBLE) || defined(NV_IS_FLOAT128)
    return 1;
#else
    return 0;
#endif
}

/* Has inttypes.h been included ?
              &&
 Do we have MATH_MPC_NEED_LONG_LONG_INT ? */

int _has_inttypes() {
#ifdef _MSC_VER
return 0;
#else
#if defined MATH_MPC_NEED_LONG_LONG_INT
return 1;
#else
return 0;
#endif
#endif
}

SV * gmp_v(pTHX) {
#if __GNU_MP_VERSION >= 4
     return newSVpv(gmp_version, 0);
#else
     warn("From Math::MPC::gmp_v: 'gmp_version' is not implemented - returning '0'");
     return newSVpv("0", 0);
#endif
}

SV * mpfr_v(pTHX) {
     return newSVpv(mpfr_get_version(), 0);
}

/* Not yet available
SV * RMPC_MAX_PREC(mpc_t * a) {
     return newSVuv(MPC_MAX_PREC(*a));
}
*/

SV * _MPC_VERSION_MAJOR(pTHX) {
     return newSVuv(MPC_VERSION_MAJOR);
}

SV * _MPC_VERSION_MINOR(pTHX) {
     return newSVuv(MPC_VERSION_MINOR);
}

SV * _MPC_VERSION_PATCHLEVEL(pTHX) {
     return newSVuv(MPC_VERSION_PATCHLEVEL);
}

SV * _MPC_VERSION(pTHX) {
     return newSVuv(MPC_VERSION);
}

SV * _MPFR_VERSION(pTHX) {
     return newSVuv(MPFR_VERSION);
}

SV * _MPC_VERSION_NUM(pTHX_ SV * x, SV * y, SV * z) {
     return newSVuv(MPC_VERSION_NUM((unsigned long)SvUV(x), (unsigned long)SvUV(y), (unsigned long)SvUV(z)));
}

SV * _MPC_VERSION_STRING(pTHX) {
     return newSVpv(MPC_VERSION_STRING, 0);
}

SV * Rmpc_get_version(pTHX) {
     return newSVpv(mpc_get_version(), 0);
}

SV * Rmpc_real(pTHX_ mpfr_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_real(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_imag(pTHX_ mpfr_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_imag(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_arg(pTHX_ mpfr_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_arg(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_proj(pTHX_ mpc_t * rop, mpc_t * op, SV * round) {
     return newSViv(mpc_proj(*rop, *op, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_get_str(pTHX_ SV * base, SV * dig, mpc_t * op, SV * round) {
     char * out;
     SV * outsv;
     out = mpc_get_str((int)SvIV(base), (size_t)SvUV(dig), *op, (mpc_rnd_t)SvUV(round));
     outsv = newSVpv(out, 0);
     mpc_free_str(out);
     return outsv;
}

int  Rmpc_set_str(pTHX_ mpc_t * rop, SV * str, SV * base, SV * round) {
     int ret;
     ret = mpc_set_str(*rop, SvPV_nolen(str), (int)SvIV(base), (mpc_rnd_t)SvUV(round));
     if(ret == -1)croak("Invalid string given to Rmpc_set_str");
     return ret;
}

int  Rmpc_strtoc(pTHX_ mpc_t * rop, SV * str, SV * base, SV * round) {
     int ret;
     ret = mpc_strtoc(*rop, SvPV_nolen(str), NULL, (int)SvIV(base), (mpc_rnd_t)SvUV(round));
     if(ret == -1) croak("Invalid string given to Rmpc_strtoc");
     return ret;
}

void Rmpc_set_nan(mpc_t * a) {
     mpc_set_nan(*a);
}

void Rmpc_swap(mpc_t * a, mpc_t * b) {
     mpc_swap(*a, *b);
}

/* atan2(x, y) = atan(x / y) */
SV * overload_atan2(pTHX_ mpc_t * p, mpc_t * q, SV * third) {
     dMY_CXT;
     mpc_t * mpc_t_obj;
     SV * obj_ref, * obj;

     New(1, mpc_t_obj, 1, mpc_t);
     if(mpc_t_obj == NULL) croak("Failed to allocate memory in overload_atan2 function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPC");
     mpc_init3(*mpc_t_obj, DEFAULT_PREC);

     mpc_div(*mpc_t_obj, *p, *q, DEFAULT_ROUNDING_MODE);

     mpc_atan(*mpc_t_obj, *mpc_t_obj, DEFAULT_ROUNDING_MODE);
     sv_setiv(obj, INT2PTR(IV,mpc_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpc_sin_cos(pTHX_ mpc_t * rop_sin, mpc_t * rop_cos, mpc_t * op, SV * rnd_sin, SV * rnd_cos) {
#ifdef SIN_COS_AVAILABLE
     return newSViv(mpc_sin_cos(*rop_sin, *rop_cos, *op, (mpc_rnd_t)SvUV(rnd_sin), (mpc_rnd_t)SvUV(rnd_cos)));
#else
     croak("Rmpc_sin_cos not supported by your version (%s) of the mpc library", MPC_VERSION_STRING);
#endif
}

void Rmpc_get_dc(pTHX_ SV * crop, mpc_t * op, SV * round) {
#ifdef _DO_COMPLEX_H
     warn("Rmpc_get_dc is deprecated - use Rmpc_get_DC instead\n");
     if(sv_isobject(crop)) {
       const char *h = HvNAME(SvSTASH(SvRV(crop)));
       if(strNE(h, "Math::Complex_C"))
         croak("1st arg to Rmpc_get_dc is a %s object - needs to be a Math::Complex_C object", h);
     }
     else croak("1st arg to Rmpc_get_dc needs to be a Math::Complex_C object");
     *(INT2PTR(double _Complex *, SvIVX(SvRV(crop)))) = mpc_get_dc(*op, (mpc_rnd_t)SvUV(round));
#else
     croak("Rmpc_get_dc not implemented");
#endif
}

void Rmpc_get_ldc(pTHX_ SV * crop, mpc_t * op, SV * round) {
#ifdef _DO_COMPLEX_H
     warn("Rmpc_get_ldc is deprecated - use Rmpc_get_LDC instead\n");
     if(sv_isobject(crop)) {
       const char *h = HvNAME(SvSTASH(SvRV(crop)));
       if(strNE(h, "Math::Complex_C::L"))
         croak("1st arg to Rmpc_get_ldc is a %s object - needs to be a Math::Complex_C::L object", h);
     }
     else croak("1st arg to Rmpc_get_ldc needs to be a Math::Complex_C::L object");
     *(INT2PTR(long double _Complex *, SvIVX(SvRV(crop)))) = mpc_get_ldc(*op, (mpc_rnd_t)SvUV(round));
#else
     croak("Rmpc_get_ldc not implemented");
#endif
}

SV * Rmpc_set_dc(pTHX_ mpc_t * op, SV * crop, SV * round) {
#ifdef _DO_COMPLEX_H
     warn("Rmpc_set_dc is deprecated - use Rmpc_set_DC instead\n");
     if(sv_isobject(crop)) {
       const char *h = HvNAME(SvSTASH(SvRV(crop)));
       if(strNE(h, "Math::Complex_C"))
         croak("2nd arg to Rmpc_set_dc is a %s object - needs to be a Math::Complex_C object", h);
     }
     else croak("2nd arg to Rmpc_set_dc needs to be a Math::Complex_C object");
     return newSViv(mpc_set_dc(*op, *(INT2PTR(double _Complex *, SvIVX(SvRV(crop)))), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_dc not implemented");
#endif
}

SV * Rmpc_set_ldc(pTHX_ mpc_t * op, SV * crop, SV * round) {
#ifdef _DO_COMPLEX_H
     warn("Rmpc_set_ldc is deprecated - use Rmpc_set_LDC instead\n");
     if(sv_isobject(crop)) {
       const char *h = HvNAME(SvSTASH(SvRV(crop)));
       if(strNE(h, "Math::Complex_C::L"))
       croak("2nd arg to Rmpc_set_ldc is a %s object - needs to be a Math::Complex_C::L object", h);
     }
     else croak("2nd arg to Rmpc_set_ldc needs to be a Math::Complex_C::L object");
     return newSViv(mpc_set_ldc(*op, *(INT2PTR(long double _Complex *, SvIVX(SvRV(crop)))), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_ldc not implemented");
#endif
}

/**********************************
 **********************************/

void Rmpc_get_DC(pTHX_ SV * crop, mpc_t * op, SV * round) {
#ifdef _DO_COMPLEX_H
     if(sv_isobject(crop)) {
       const char *h = HvNAME(SvSTASH(SvRV(crop)));
       if(strNE(h, "Math::Complex_C"))
         croak("1st arg to Rmpc_get_DC is a %s object - needs to be a Math::Complex_C object", h);
     }
     else croak("1st arg to Rmpc_get_DC needs to be a Math::Complex_C object");
     *(INT2PTR(double _Complex *, SvIVX(SvRV(crop)))) = mpc_get_dc(*op, (mpc_rnd_t)SvUV(round));
#else
     croak("Rmpc_get_DC not implemented");
#endif
}

void Rmpc_get_LDC(pTHX_ SV * crop, mpc_t * op, SV * round) {
#ifdef _DO_COMPLEX_H
     if(sv_isobject(crop)) {
       const char *h = HvNAME(SvSTASH(SvRV(crop)));
       if(strNE(h, "Math::Complex_C::L"))
         croak("1st arg to Rmpc_get_LDC is a %s object - needs to be a Math::Complex_C::L object", h);
     }
     else croak("1st arg to Rmpc_get_LDC needs to be a Math::Complex_C::L object");
     *(INT2PTR(long double _Complex *, SvIVX(SvRV(crop)))) = mpc_get_ldc(*op, (mpc_rnd_t)SvUV(round));
#else
     croak("Rmpc_get_LDC not implemented");
#endif
}

SV * Rmpc_set_DC(pTHX_ mpc_t * op, SV * crop, SV * round) {
#ifdef _DO_COMPLEX_H
     if(sv_isobject(crop)) {
       const char *h = HvNAME(SvSTASH(SvRV(crop)));
       if(strNE(h, "Math::Complex_C"))
         croak("2nd arg to Rmpc_set_DC is a %s object - needs to be a Math::Complex_C object", h);
     }
     else croak("2nd arg to Rmpc_set_DC needs to be a Math::Complex_C object");
     return newSViv(mpc_set_dc(*op, *(INT2PTR(double _Complex *, SvIVX(SvRV(crop)))), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_DC not implemented");
#endif
}

SV * Rmpc_set_LDC(pTHX_ mpc_t * op, SV * crop, SV * round) {
#ifdef _DO_COMPLEX_H
     if(sv_isobject(crop)) {
       const char *h = HvNAME(SvSTASH(SvRV(crop)));
       if(strNE(h, "Math::Complex_C::L"))
       croak("2nd arg to Rmpc_set_LDC is a %s object - needs to be a Math::Complex_C::L object", h);
     }
     else croak("2nd arg to Rmpc_set_LDC needs to be a Math::Complex_C::L object");
     return newSViv(mpc_set_ldc(*op, *(INT2PTR(long double _Complex *, SvIVX(SvRV(crop)))), (mpc_rnd_t)SvUV(round)));
#else
     croak("Rmpc_set_LDC not implemented");
#endif
}

/**********************************
 **********************************/


/**********************************
 **********************************/

int _have_Complex_h(void) {
#ifdef _DO_COMPLEX_H
     return 1;
#else
     return 0;
#endif
}

SV * _mpfr_buildopt_tls_p(pTHX) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_buildopt_tls_p());
#else
     croak("Math::MPC::_mpfr_buildopt_tls_p not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * _get_xs_version(pTHX) {
     return newSVpv(XS_VERSION, 0);
}

SV * _wrap_count(pTHX) {
     return newSVuv(PL_sv_count);
}

/* Beginning mpc-1.0, mpc_mul_2si and mpc_div_2si were added */

SV * Rmpc_mul_2si(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round) {
#if MPC_VERSION >= 65536
     return newSViv(mpc_mul_2si(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
# else
     croak("mpc_mul_2si not implemented until mpc-1.0. We have version %d", MPC_VERSION);
#endif
}

SV * Rmpc_div_2si(pTHX_ mpc_t * a, mpc_t * b, SV * c, SV * round) {
#if MPC_VERSION >= 65536
     return newSViv(mpc_div_2si(*a, *b, SvUV(c), (mpc_rnd_t)SvUV(round)));
# else
     croak("mpc_div_2si not implemented until mpc-1.0. We have version %d", MPC_VERSION);
#endif
}

SV * Rmpc_log10(pTHX_ mpc_t * rop, mpc_t *op, SV * round) {
#if MPC_VERSION >= 65536
     return newSViv(mpc_log10(*rop, *op, (mpc_rnd_t)SvUV(round)));
# else
     croak("mpc_log10 not implemented until mpc-1.0. We have version %d", MPC_VERSION);
#endif
}

int Rmpc_cmp_abs(mpc_t * op1, mpc_t * op2) {
#if (!defined(MPC_VERSION) || (MPC_VERSION<MPC_VERSION_NUM(1,1,0)))
     croak("Rmpc_cmp_abs not available - need mpc-1.1.0 or later");
#else
     return mpc_cmp_abs(*op1, *op2);
#endif
}

int Rmpc_rootofunity(pTHX_ mpc_t * rop, unsigned long n, unsigned long k, SV * round) {
#if (!defined(MPC_VERSION) || (MPC_VERSION<MPC_VERSION_NUM(1,1,0)))
     croak("Rmpc_rootofunity not available - need mpc-1.1.0 or later");
#else
    return mpc_rootofunity(*rop, n, k, (mpc_rnd_t)SvUV(round));
#endif
}

int _can_pass_float128(void) {

#ifdef MPC_CAN_PASS_FLOAT128
   return 1;
#else
   return 0;
#endif

}

int _get_nv_precision(void) {
#if defined(NV_IS_FLOAT128)
 return 113;
#elif defined(NV_IS_LONG_DOUBLE)
 return (int) REQUIRED_LDBL_MANT_DIG;
#else
 return 53;
#endif
}


int nok_pokflag(void) {
  return nok_pok;
}

void clear_nok_pok(void){
  nok_pok = 0;
}

void set_nok_pok(int x) {
  nok_pok = x;
}

int _SvNOK(pTHX_ SV * in) {
  if(SvNOK(in)) return 1;
  return 0;
}

int _SvPOK(pTHX_ SV * in) {
  if(SvPOK(in)) return 1;
  return 0;
}

SV * Rmpc_fma(pTHX_ mpc_t * a, mpc_t * b, mpc_t * c, mpc_t * d, SV * round) {
     return newSViv(mpc_fma(*a, *b, *c, *d, (mpc_rnd_t)SvUV(round)));
}

SV * Rmpc_dot(pTHX_ mpc_t * rop, SV * avref_A, SV * avref_B, SV * len, SV * round) {
#if defined(MPC_VERSION) && MPC_VERSION >= 65793 /* version 1.1.1 */
     mpc_ptr *p_A, *p_B;
     SV ** elem;
     int ret, i;
     unsigned long s = (unsigned long)SvUV(len);

     if(s > av_len((AV*)SvRV(avref_A)) + 1 || s > av_len((AV*)SvRV(avref_B)) + 1)
       croak("2nd last arg to Rmpc_dot is too large");

     Newx(p_A, s, mpc_ptr);
     if(p_A == NULL) croak("Unable to allocate memory for first pointer array in Rmpc_dot");

     Newx(p_B, s, mpc_ptr);
     if(p_B == NULL) croak("Unable to allocate memory for second pointer array in Rmpc_dot");

     for(i = 0; i < s; ++i) {
       elem = av_fetch((AV*)SvRV(avref_A), i, 0);
       p_A[i] = *(INT2PTR(mpc_t *, SvIVX(SvRV(*elem))));
       elem = av_fetch((AV*)SvRV(avref_B), i, 0);
       p_B[i] = *(INT2PTR(mpc_t *, SvIVX(SvRV(*elem))));
     }

     ret = mpc_dot(*rop, p_A, p_B, s, (mpc_rnd_t)SvUV(round));

     Safefree(p_A);
     Safefree(p_B);
     return newSViv(ret);
#else
    croak("The Rmpc_dot function requires mpc-1.1.1 or later");
#endif
}

SV * Rmpc_sum(pTHX_ mpc_t * rop, SV * avref, SV * len, SV * round) {
#if defined(MPC_VERSION) && MPC_VERSION >= 65793 /* version 1.1.1 */
     mpc_ptr *p;
     SV ** elem;
     int ret, i;
     unsigned long s = (unsigned long)SvUV(len);

     if(s > av_len((AV*)SvRV(avref)) + 1)croak("2nd last arg to Rmpc_sum is greater than the size of the array");

     Newx(p, s, mpc_ptr);
     if(p == NULL) croak("Unable to allocate memory in Rmpc_sum");

     for(i = 0; i < s; ++i) {
        elem = av_fetch((AV*)SvRV(avref), i, 0);
        p[i] = *(INT2PTR(mpc_t *, SvIVX(SvRV(*elem))));
     }

     ret = mpc_sum(*rop, p, s, (mpc_rnd_t)SvUV(round));

     Safefree(p);
     return newSViv(ret);
#else
    croak("The Rmpc_sum function requires mpc-1.1.1 or later");
#endif
}

/* I think the CLONE function needs to come at the very end ... not sure */

void CLONE(pTHX_ SV * x, ...) {
   MY_CXT_CLONE;
}



#line 3840 "MPC.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 3984 "MPC.c"

XS_EUPXS(XS_Math__MPC_NOK_POK_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_NOK_POK_val)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 3838 "MPC.xs"
  RETVAL = NOK_POK_val (aTHX);
#line 3997 "MPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__win32_infnanstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__win32_infnanstring)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	char *	s = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _win32_infnanstring(s);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, i, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(1))))
;
	intmax_t            i = (intmax_t)SvIV(ST(2))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_mul_sj(rop, op, i, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, i, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(1))))
;
	long double            i = (long double)SvNV(ST(2))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_mul_ld(rop, op, i, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, i, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(1))))
;
	double	i = (double)SvNV(ST(2))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_mul_d(rop, op, i, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_div_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_div_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, i, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(1))))
;
	intmax_t            i = (intmax_t)SvIV(ST(2))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_div_sj(rop, op, i, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sj_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sj_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, i, op, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	intmax_t            i = (intmax_t)SvIV(ST(1))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(2))))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_sj_div(rop, i, op, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_div_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_div_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, i, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(1))))
;
	long double            i = (long double)SvNV(ST(2))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_div_ld(rop, op, i, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_ld_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_ld_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, i, op, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	long double            i = (long double)SvNV(ST(1))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(2))))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_ld_div(rop, i, op, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_div_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_div_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, i, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(1))))
;
	double	i = (double)SvNV(ST(2))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_div_d(rop, op, i, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_d_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_d_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, i, op, rnd");
    {
	mpc_ptr            rop = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(0))))
;
	double	i = (double)SvNV(ST(1))
;
	mpc_ptr            op = INT2PTR(mpc_ptr, SvIVX(SvRV(ST(2))))
;
	mpc_rnd_t            rnd = (mpc_rnd_t)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_d_div(rop, i, op, rnd);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__mpfr_set_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__mpfr_set_NV)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	unsigned int	round = (unsigned int)SvUV(ST(2))
;
	SV *	RETVAL;
#line 3915 "MPC.xs"
  RETVAL = _mpfr_set_NV (aTHX_ p, q, round);
#line 4264 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_default_rounding_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_default_rounding_mode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	round = ST(0)
;
#line 3922 "MPC.xs"
        I32* temp;
#line 4285 "MPC.c"
#line 3924 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_set_default_rounding_mode(aTHX_ round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4296 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_default_rounding_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_default_rounding_mode)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3937 "MPC.xs"
  RETVAL = Rmpc_get_default_rounding_mode (aTHX);
#line 4313 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_default_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_default_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	prec = ST(0)
;
#line 3945 "MPC.xs"
        I32* temp;
#line 4334 "MPC.c"
#line 3947 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_set_default_prec(aTHX_ prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4345 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_default_prec2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_default_prec2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "prec_re, prec_im");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	prec_re = ST(0)
;
	SV *	prec_im = ST(1)
;
#line 3962 "MPC.xs"
        I32* temp;
#line 4367 "MPC.c"
#line 3964 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_set_default_prec2(aTHX_ prec_re, prec_im);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4378 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_default_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_default_prec)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3977 "MPC.xs"
  RETVAL = Rmpc_get_default_prec (aTHX);
#line 4395 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_default_prec2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_default_prec2)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 3985 "MPC.xs"
        I32* temp;
#line 4414 "MPC.c"
#line 3987 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_get_default_prec2();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4425 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_prec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 4002 "MPC.xs"
        I32* temp;
#line 4447 "MPC.c"
#line 4004 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_set_prec(aTHX_ p, prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4458 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_re_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_re_prec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 4019 "MPC.xs"
        I32* temp;
#line 4480 "MPC.c"
#line 4021 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_set_re_prec(aTHX_ p, prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4491 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_im_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_im_prec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 4036 "MPC.xs"
        I32* temp;
#line 4513 "MPC.c"
#line 4038 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_set_im_prec(aTHX_ p, prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4524 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	mpc_t *            x = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 4052 "MPC.xs"
  RETVAL = Rmpc_get_prec (aTHX_ x);
#line 4543 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_prec2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_prec2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            x = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
#line 4059 "MPC.xs"
        I32* temp;
#line 4564 "MPC.c"
#line 4061 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_get_prec2(aTHX_ x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4575 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_im_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_im_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	mpc_t *            x = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 4075 "MPC.xs"
  RETVAL = Rmpc_get_im_prec (aTHX_ x);
#line 4594 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_re_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_re_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	mpc_t *            x = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 4082 "MPC.xs"
  RETVAL = Rmpc_get_re_prec (aTHX_ x);
#line 4614 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_RMPC_RE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_RMPC_RE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fr, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            fr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            x = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
#line 4090 "MPC.xs"
        I32* temp;
#line 4637 "MPC.c"
#line 4092 "MPC.xs"
        temp = PL_markstack_ptr++;
        RMPC_RE(fr, x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4648 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_RMPC_IM); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_RMPC_IM)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fr, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            fr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            x = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
#line 4107 "MPC.xs"
        I32* temp;
#line 4670 "MPC.c"
#line 4109 "MPC.xs"
        temp = PL_markstack_ptr++;
        RMPC_IM(fr, x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4681 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_RMPC_INEX_RE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_RMPC_INEX_RE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	SV *	RETVAL;
#line 4123 "MPC.xs"
  RETVAL = RMPC_INEX_RE (aTHX_ x);
#line 4700 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_RMPC_INEX_IM); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_RMPC_INEX_IM)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	SV *	RETVAL;
#line 4130 "MPC.xs"
  RETVAL = RMPC_INEX_IM (aTHX_ x);
#line 4720 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
#line 4137 "MPC.xs"
        I32* temp;
#line 4741 "MPC.c"
#line 4139 "MPC.xs"
        temp = PL_markstack_ptr++;
        DESTROY(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4752 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
#line 4153 "MPC.xs"
        I32* temp;
#line 4772 "MPC.c"
#line 4155 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_clear(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4783 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_clear_mpc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_clear_mpc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
#line 4169 "MPC.xs"
        I32* temp;
#line 4803 "MPC.c"
#line 4171 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_clear_mpc(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4814 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_clear_ptr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_clear_ptr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
#line 4185 "MPC.xs"
        I32* temp;
#line 4834 "MPC.c"
#line 4187 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_clear_ptr(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4845 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_init2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_init2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    {
	SV *	prec = ST(0)
;
	SV *	RETVAL;
#line 4201 "MPC.xs"
  RETVAL = Rmpc_init2 (aTHX_ prec);
#line 4864 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_init3); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_init3)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "prec_r, prec_i");
    {
	SV *	prec_r = ST(0)
;
	SV *	prec_i = ST(1)
;
	SV *	RETVAL;
#line 4209 "MPC.xs"
  RETVAL = Rmpc_init3 (aTHX_ prec_r, prec_i);
#line 4886 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_init2_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_init2_nobless)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    {
	SV *	prec = ST(0)
;
	SV *	RETVAL;
#line 4216 "MPC.xs"
  RETVAL = Rmpc_init2_nobless (aTHX_ prec);
#line 4906 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_init3_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_init3_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "prec_r, prec_i");
    {
	SV *	prec_r = ST(0)
;
	SV *	prec_i = ST(1)
;
	SV *	RETVAL;
#line 4224 "MPC.xs"
  RETVAL = Rmpc_init3_nobless (aTHX_ prec_r, prec_i);
#line 4928 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            q = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4233 "MPC.xs"
  RETVAL = Rmpc_set (aTHX_ p, q, round);
#line 4952 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4242 "MPC.xs"
  RETVAL = Rmpc_set_ui (aTHX_ p, q, round);
#line 4976 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4251 "MPC.xs"
  RETVAL = Rmpc_set_si (aTHX_ p, q, round);
#line 5000 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4260 "MPC.xs"
  RETVAL = Rmpc_set_ld (aTHX_ p, q, round);
#line 5024 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_NV)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	unsigned int	round = (unsigned int)SvUV(ST(2))
;
	SV *	RETVAL;
#line 4269 "MPC.xs"
  RETVAL = Rmpc_set_NV (aTHX_ p, q, round);
#line 5048 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_NV_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_NV_NV)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, re_q, im_q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	re_q = ST(1)
;
	SV *	im_q = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4279 "MPC.xs"
  RETVAL = Rmpc_set_NV_NV (aTHX_ p, re_q, im_q, round);
#line 5074 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4288 "MPC.xs"
  RETVAL = Rmpc_set_uj (aTHX_ p, q, round);
#line 5098 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4297 "MPC.xs"
  RETVAL = Rmpc_set_sj (aTHX_ p, q, round);
#line 5122 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4306 "MPC.xs"
  RETVAL = Rmpc_set_z (aTHX_ p, q, round);
#line 5146 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            q = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4315 "MPC.xs"
  RETVAL = Rmpc_set_f (aTHX_ p, q, round);
#line 5170 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4324 "MPC.xs"
  RETVAL = Rmpc_set_q (aTHX_ p, q, round);
#line 5194 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4333 "MPC.xs"
  RETVAL = Rmpc_set_d (aTHX_ p, q, round);
#line 5218 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 4342 "MPC.xs"
  RETVAL = Rmpc_set_fr (aTHX_ p, q, round);
#line 5242 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, q_r, q_i, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q_r = ST(1)
;
	SV *	q_i = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4352 "MPC.xs"
  RETVAL = Rmpc_set_ui_ui (aTHX_ p, q_r, q_i, round);
#line 5268 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, q_r, q_i, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q_r = ST(1)
;
	SV *	q_i = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4362 "MPC.xs"
  RETVAL = Rmpc_set_si_si (aTHX_ p, q_r, q_i, round);
#line 5294 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, q_r, q_i, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q_r = ST(1)
;
	SV *	q_i = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4372 "MPC.xs"
  RETVAL = Rmpc_set_d_d (aTHX_ p, q_r, q_i, round);
#line 5320 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ld1, ld2, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ld1 = ST(1)
;
	SV *	ld2 = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4382 "MPC.xs"
  RETVAL = Rmpc_set_ld_ld (aTHX_ mpc, ld1, ld2, round);
#line 5346 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, q_r, q_i, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            q_r = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            q_i = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4392 "MPC.xs"
  RETVAL = Rmpc_set_z_z (aTHX_ p, q_r, q_i, round);
#line 5372 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, q_r, q_i, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            q_r = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            q_i = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4402 "MPC.xs"
  RETVAL = Rmpc_set_q_q (aTHX_ p, q_r, q_i, round);
#line 5398 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, q_r, q_i, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            q_r = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	mpf_t *            q_i = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4412 "MPC.xs"
  RETVAL = Rmpc_set_f_f (aTHX_ p, q_r, q_i, round);
#line 5424 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, q_r, q_i, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            q_r = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            q_i = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4422 "MPC.xs"
  RETVAL = Rmpc_set_fr_fr (aTHX_ p, q_r, q_i, round);
#line 5450 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4432 "MPC.xs"
  RETVAL = Rmpc_set_d_ui (aTHX_ mpc, d, ui, round);
#line 5476 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4442 "MPC.xs"
  RETVAL = Rmpc_set_d_si (aTHX_ mpc, d, si, round);
#line 5502 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4452 "MPC.xs"
  RETVAL = Rmpc_set_d_fr (aTHX_ mpc, d, mpfr, round);
#line 5528 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4462 "MPC.xs"
  RETVAL = Rmpc_set_ui_d (aTHX_ mpc, ui, d, round);
#line 5554 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4472 "MPC.xs"
  RETVAL = Rmpc_set_ui_si (aTHX_ mpc, ui, si, round);
#line 5580 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4482 "MPC.xs"
  RETVAL = Rmpc_set_ui_fr (aTHX_ mpc, ui, mpfr, round);
#line 5606 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4492 "MPC.xs"
  RETVAL = Rmpc_set_si_d (aTHX_ mpc, si, d, round);
#line 5632 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4502 "MPC.xs"
  RETVAL = Rmpc_set_si_ui (aTHX_ mpc, si, ui, round);
#line 5658 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4512 "MPC.xs"
  RETVAL = Rmpc_set_si_fr (aTHX_ mpc, si, mpfr, round);
#line 5684 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4522 "MPC.xs"
  RETVAL = Rmpc_set_fr_d (aTHX_ mpc, mpfr, d, round);
#line 5710 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4532 "MPC.xs"
  RETVAL = Rmpc_set_fr_ui (aTHX_ mpc, mpfr, ui, round);
#line 5736 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4542 "MPC.xs"
  RETVAL = Rmpc_set_fr_si (aTHX_ mpc, mpfr, si, round);
#line 5762 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4552 "MPC.xs"
  RETVAL = Rmpc_set_ld_ui (aTHX_ mpc, d, ui, round);
#line 5788 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4562 "MPC.xs"
  RETVAL = Rmpc_set_ld_si (aTHX_ mpc, d, si, round);
#line 5814 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4572 "MPC.xs"
  RETVAL = Rmpc_set_ld_fr (aTHX_ mpc, d, mpfr, round);
#line 5840 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4582 "MPC.xs"
  RETVAL = Rmpc_set_ui_ld (aTHX_ mpc, ui, d, round);
#line 5866 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4592 "MPC.xs"
  RETVAL = Rmpc_set_si_ld (aTHX_ mpc, si, d, round);
#line 5892 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4602 "MPC.xs"
  RETVAL = Rmpc_set_fr_ld (aTHX_ mpc, mpfr, d, round);
#line 5918 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4612 "MPC.xs"
  RETVAL = Rmpc_set_d_uj (aTHX_ mpc, d, ui, round);
#line 5944 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4622 "MPC.xs"
  RETVAL = Rmpc_set_d_sj (aTHX_ mpc, d, si, round);
#line 5970 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4632 "MPC.xs"
  RETVAL = Rmpc_set_sj_d (aTHX_ mpc, si, d, round);
#line 5996 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4642 "MPC.xs"
  RETVAL = Rmpc_set_uj_d (aTHX_ mpc, ui, d, round);
#line 6022 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4652 "MPC.xs"
  RETVAL = Rmpc_set_uj_fr (aTHX_ mpc, ui, mpfr, round);
#line 6048 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4662 "MPC.xs"
  RETVAL = Rmpc_set_sj_fr (aTHX_ mpc, si, mpfr, round);
#line 6074 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4672 "MPC.xs"
  RETVAL = Rmpc_set_fr_uj (aTHX_ mpc, mpfr, ui, round);
#line 6100 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4682 "MPC.xs"
  RETVAL = Rmpc_set_fr_sj (aTHX_ mpc, mpfr, si, round);
#line 6126 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4692 "MPC.xs"
  RETVAL = Rmpc_set_uj_sj (aTHX_ mpc, ui, si, round);
#line 6152 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4702 "MPC.xs"
  RETVAL = Rmpc_set_sj_uj (aTHX_ mpc, si, ui, round);
#line 6178 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4712 "MPC.xs"
  RETVAL = Rmpc_set_ld_uj (aTHX_ mpc, d, ui, round);
#line 6204 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4722 "MPC.xs"
  RETVAL = Rmpc_set_ld_sj (aTHX_ mpc, d, si, round);
#line 6230 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4732 "MPC.xs"
  RETVAL = Rmpc_set_uj_ld (aTHX_ mpc, ui, d, round);
#line 6256 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4742 "MPC.xs"
  RETVAL = Rmpc_set_sj_ld (aTHX_ mpc, si, d, round);
#line 6282 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4752 "MPC.xs"
  RETVAL = Rmpc_set_f_ui (aTHX_ mpc, mpf, ui, round);
#line 6308 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4762 "MPC.xs"
  RETVAL = Rmpc_set_q_ui (aTHX_ mpc, mpq, ui, round);
#line 6334 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, ui, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	ui = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4772 "MPC.xs"
  RETVAL = Rmpc_set_z_ui (aTHX_ mpc, mpz, ui, round);
#line 6360 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4782 "MPC.xs"
  RETVAL = Rmpc_set_f_si (aTHX_ mpc, mpf, si, round);
#line 6386 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4792 "MPC.xs"
  RETVAL = Rmpc_set_q_si (aTHX_ mpc, mpq, si, round);
#line 6412 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, si, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	si = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4802 "MPC.xs"
  RETVAL = Rmpc_set_z_si (aTHX_ mpc, mpz, si, round);
#line 6438 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4812 "MPC.xs"
  RETVAL = Rmpc_set_f_d (aTHX_ mpc, mpf, d, round);
#line 6464 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4822 "MPC.xs"
  RETVAL = Rmpc_set_q_d (aTHX_ mpc, mpq, d, round);
#line 6490 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, d, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	d = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4832 "MPC.xs"
  RETVAL = Rmpc_set_z_d (aTHX_ mpc, mpz, d, round);
#line 6516 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, uj, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	uj = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4842 "MPC.xs"
  RETVAL = Rmpc_set_f_uj (aTHX_ mpc, mpf, uj, round);
#line 6542 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, uj, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	uj = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4852 "MPC.xs"
  RETVAL = Rmpc_set_q_uj (aTHX_ mpc, mpq, uj, round);
#line 6568 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, uj, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	uj = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4862 "MPC.xs"
  RETVAL = Rmpc_set_z_uj (aTHX_ mpc, mpz, uj, round);
#line 6594 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, sj, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	sj = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4872 "MPC.xs"
  RETVAL = Rmpc_set_f_sj (aTHX_ mpc, mpf, sj, round);
#line 6620 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, sj, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	sj = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4882 "MPC.xs"
  RETVAL = Rmpc_set_q_sj (aTHX_ mpc, mpq, sj, round);
#line 6646 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, sj, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	sj = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4892 "MPC.xs"
  RETVAL = Rmpc_set_z_sj (aTHX_ mpc, mpz, sj, round);
#line 6672 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, ld, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	ld = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4902 "MPC.xs"
  RETVAL = Rmpc_set_f_ld (aTHX_ mpc, mpf, ld, round);
#line 6698 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, ld, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	ld = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4912 "MPC.xs"
  RETVAL = Rmpc_set_q_ld (aTHX_ mpc, mpq, ld, round);
#line 6724 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, ld, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	ld = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4922 "MPC.xs"
  RETVAL = Rmpc_set_z_ld (aTHX_ mpc, mpz, ld, round);
#line 6750 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4932 "MPC.xs"
  RETVAL = Rmpc_set_ui_f (aTHX_ mpc, ui, mpf, round);
#line 6776 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4942 "MPC.xs"
  RETVAL = Rmpc_set_ui_q (aTHX_ mpc, ui, mpq, round);
#line 6802 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ui_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ui, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ui = ST(1)
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4952 "MPC.xs"
  RETVAL = Rmpc_set_ui_z (aTHX_ mpc, ui, mpz, round);
#line 6828 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4962 "MPC.xs"
  RETVAL = Rmpc_set_si_f (aTHX_ mpc, si, mpf, round);
#line 6854 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4972 "MPC.xs"
  RETVAL = Rmpc_set_si_q (aTHX_ mpc, si, mpq, round);
#line 6880 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_si_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_si_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, si, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	si = ST(1)
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4982 "MPC.xs"
  RETVAL = Rmpc_set_si_z (aTHX_ mpc, si, mpz, round);
#line 6906 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 4992 "MPC.xs"
  RETVAL = Rmpc_set_d_f (aTHX_ mpc, d, mpf, round);
#line 6932 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5002 "MPC.xs"
  RETVAL = Rmpc_set_d_q (aTHX_ mpc, d, mpq, round);
#line 6958 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_d_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_d_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, d, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	d = ST(1)
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5012 "MPC.xs"
  RETVAL = Rmpc_set_d_z (aTHX_ mpc, d, mpz, round);
#line 6984 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, uj, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	uj = ST(1)
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5022 "MPC.xs"
  RETVAL = Rmpc_set_uj_f (aTHX_ mpc, uj, mpf, round);
#line 7010 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, uj, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	uj = ST(1)
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5032 "MPC.xs"
  RETVAL = Rmpc_set_uj_q (aTHX_ mpc, uj, mpq, round);
#line 7036 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, uj, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	uj = ST(1)
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5042 "MPC.xs"
  RETVAL = Rmpc_set_uj_z (aTHX_ mpc, uj, mpz, round);
#line 7062 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, sj, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	sj = ST(1)
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5052 "MPC.xs"
  RETVAL = Rmpc_set_sj_f (aTHX_ mpc, sj, mpf, round);
#line 7088 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, sj, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	sj = ST(1)
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5062 "MPC.xs"
  RETVAL = Rmpc_set_sj_q (aTHX_ mpc, sj, mpq, round);
#line 7114 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, sj, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	sj = ST(1)
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5072 "MPC.xs"
  RETVAL = Rmpc_set_sj_z (aTHX_ mpc, sj, mpz, round);
#line 7140 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ld, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ld = ST(1)
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5082 "MPC.xs"
  RETVAL = Rmpc_set_ld_f (aTHX_ mpc, ld, mpf, round);
#line 7166 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ld, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ld = ST(1)
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5092 "MPC.xs"
  RETVAL = Rmpc_set_ld_q (aTHX_ mpc, ld, mpq, round);
#line 7192 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ld_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, ld, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	ld = ST(1)
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5102 "MPC.xs"
  RETVAL = Rmpc_set_ld_z (aTHX_ mpc, ld, mpz, round);
#line 7218 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5112 "MPC.xs"
  RETVAL = Rmpc_set_f_q (aTHX_ mpc, mpf, mpq, round);
#line 7244 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5122 "MPC.xs"
  RETVAL = Rmpc_set_q_f (aTHX_ mpc, mpq, mpf, round);
#line 7270 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5132 "MPC.xs"
  RETVAL = Rmpc_set_f_z (aTHX_ mpc, mpf, mpz, round);
#line 7296 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5142 "MPC.xs"
  RETVAL = Rmpc_set_z_f (aTHX_ mpc, mpz, mpf, round);
#line 7322 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5152 "MPC.xs"
  RETVAL = Rmpc_set_q_z (aTHX_ mpc, mpq, mpz, round);
#line 7348 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5162 "MPC.xs"
  RETVAL = Rmpc_set_z_q (aTHX_ mpc, mpz, mpq, round);
#line 7374 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_f_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_f_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpf, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5172 "MPC.xs"
  RETVAL = Rmpc_set_f_fr (aTHX_ mpc, mpf, mpfr, round);
#line 7400 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_f)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, mpf, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpf_t *            mpf = INT2PTR(mpf_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5182 "MPC.xs"
  RETVAL = Rmpc_set_fr_f (aTHX_ mpc, mpfr, mpf, round);
#line 7426 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_q_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_q_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpq, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5192 "MPC.xs"
  RETVAL = Rmpc_set_q_fr (aTHX_ mpc, mpq, mpfr, round);
#line 7452 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, mpq, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            mpq = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5202 "MPC.xs"
  RETVAL = Rmpc_set_fr_q (aTHX_ mpc, mpfr, mpq, round);
#line 7478 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_z_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_z_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpz, mpfr, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5212 "MPC.xs"
  RETVAL = Rmpc_set_z_fr (aTHX_ mpc, mpz, mpfr, round);
#line 7504 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_fr_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, mpfr, mpz, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            mpfr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            mpz = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5222 "MPC.xs"
  RETVAL = Rmpc_set_fr_z (aTHX_ mpc, mpfr, mpz, round);
#line 7530 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_uj_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, uj1, uj2, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	uj1 = ST(1)
;
	SV *	uj2 = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5232 "MPC.xs"
  RETVAL = Rmpc_set_uj_uj (aTHX_ mpc, uj1, uj2, round);
#line 7556 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_sj_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "mpc, sj1, sj2, round");
    {
	mpc_t *            mpc = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	sj1 = ST(1)
;
	SV *	sj2 = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5242 "MPC.xs"
  RETVAL = Rmpc_set_sj_sj (aTHX_ mpc, sj1, sj2, round);
#line 7582 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_add)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpc_t *            c = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5252 "MPC.xs"
  RETVAL = Rmpc_add (aTHX_ a, b, c, round);
#line 7608 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_add_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_add_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5262 "MPC.xs"
  RETVAL = Rmpc_add_ui (aTHX_ a, b, c, round);
#line 7634 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_add_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_add_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5272 "MPC.xs"
  RETVAL = Rmpc_add_fr (aTHX_ a, b, c, round);
#line 7660 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpc_t *            c = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5282 "MPC.xs"
  RETVAL = Rmpc_sub (aTHX_ a, b, c, round);
#line 7686 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sub_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sub_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5292 "MPC.xs"
  RETVAL = Rmpc_sub_ui (aTHX_ a, b, c, round);
#line 7712 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_ui_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_ui_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpc_t *            c = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5302 "MPC.xs"
  RETVAL = Rmpc_ui_sub (aTHX_ a, b, c, round);
#line 7738 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_ui_ui_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_ui_ui_sub)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b_r, b_i, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b_r = ST(1)
;
	SV *	b_i = ST(2)
;
	mpc_t *            c = INT2PTR(mpc_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 5313 "MPC.xs"
  RETVAL = Rmpc_ui_ui_sub (aTHX_ a, b_r, b_i, c, round);
#line 7766 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpc_t *            c = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5323 "MPC.xs"
  RETVAL = Rmpc_mul (aTHX_ a, b, c, round);
#line 7792 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5333 "MPC.xs"
  RETVAL = Rmpc_mul_ui (aTHX_ a, b, c, round);
#line 7818 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5343 "MPC.xs"
  RETVAL = Rmpc_mul_si (aTHX_ a, b, c, round);
#line 7844 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5353 "MPC.xs"
  RETVAL = Rmpc_mul_fr (aTHX_ a, b, c, round);
#line 7870 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_i); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_i)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, sign, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	sign = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5363 "MPC.xs"
  RETVAL = Rmpc_mul_i (aTHX_ a, b, sign, round);
#line 7896 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sqr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sqr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5372 "MPC.xs"
  RETVAL = Rmpc_sqr (aTHX_ a, b, round);
#line 7920 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpc_t *            c = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5382 "MPC.xs"
  RETVAL = Rmpc_div (aTHX_ a, b, c, round);
#line 7946 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_div_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_div_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5392 "MPC.xs"
  RETVAL = Rmpc_div_ui (aTHX_ a, b, c, round);
#line 7972 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_ui_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_ui_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpc_t *            c = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5402 "MPC.xs"
  RETVAL = Rmpc_ui_div (aTHX_ a, b, c, round);
#line 7998 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_div_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_div_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5412 "MPC.xs"
  RETVAL = Rmpc_div_fr (aTHX_ a, b, c, round);
#line 8024 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5421 "MPC.xs"
  RETVAL = Rmpc_sqrt (aTHX_ a, b, round);
#line 8048 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_pow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, pow, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpc_t *            pow = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5431 "MPC.xs"
  RETVAL = Rmpc_pow (aTHX_ a, b, pow, round);
#line 8074 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_pow_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_pow_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, pow, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	pow = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5441 "MPC.xs"
  RETVAL = Rmpc_pow_d (aTHX_ a, b, pow, round);
#line 8100 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_pow_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_pow_ld)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, pow, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	pow = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5451 "MPC.xs"
  RETVAL = Rmpc_pow_ld (aTHX_ a, b, pow, round);
#line 8126 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_pow_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_pow_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, pow, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	pow = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5461 "MPC.xs"
  RETVAL = Rmpc_pow_si (aTHX_ a, b, pow, round);
#line 8152 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_pow_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_pow_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, pow, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	pow = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5471 "MPC.xs"
  RETVAL = Rmpc_pow_ui (aTHX_ a, b, pow, round);
#line 8178 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_pow_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_pow_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, pow, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            pow = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5481 "MPC.xs"
  RETVAL = Rmpc_pow_z (aTHX_ a, b, pow, round);
#line 8204 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_pow_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_pow_fr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, pow, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            pow = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5491 "MPC.xs"
  RETVAL = Rmpc_pow_fr (aTHX_ a, b, pow, round);
#line 8230 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_neg)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5500 "MPC.xs"
  RETVAL = Rmpc_neg (aTHX_ a, b, round);
#line 8254 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5509 "MPC.xs"
  RETVAL = Rmpc_abs (aTHX_ a, b, round);
#line 8278 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_conj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_conj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5518 "MPC.xs"
  RETVAL = Rmpc_conj (aTHX_ a, b, round);
#line 8302 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_norm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_norm)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5527 "MPC.xs"
  RETVAL = Rmpc_norm (aTHX_ a, b, round);
#line 8326 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_2ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_2ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5537 "MPC.xs"
  RETVAL = Rmpc_mul_2ui (aTHX_ a, b, c, round);
#line 8352 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_div_2ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_div_2ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 5547 "MPC.xs"
  RETVAL = Rmpc_div_2ui (aTHX_ a, b, c, round);
#line 8378 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	RETVAL;
#line 5555 "MPC.xs"
  RETVAL = Rmpc_cmp (aTHX_ a, b);
#line 8400 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_cmp_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_cmp_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	RETVAL;
#line 5563 "MPC.xs"
  RETVAL = Rmpc_cmp_si (aTHX_ a, b);
#line 8422 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_cmp_si_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_cmp_si_si)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	RETVAL;
#line 5572 "MPC.xs"
  RETVAL = Rmpc_cmp_si_si (aTHX_ a, b, c);
#line 8446 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5581 "MPC.xs"
  RETVAL = Rmpc_exp (aTHX_ a, b, round);
#line 8470 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5590 "MPC.xs"
  RETVAL = Rmpc_log (aTHX_ rop, op, round);
#line 8494 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__Rmpc_out_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__Rmpc_out_str)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "stream, base, dig, p, round");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 5601 "MPC.xs"
  RETVAL = _Rmpc_out_str (aTHX_ stream, base, dig, p, round);
#line 8522 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__Rmpc_out_strS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__Rmpc_out_strS)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "stream, base, dig, p, round, suff");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	suff = ST(5)
;
	SV *	RETVAL;
#line 5613 "MPC.xs"
  RETVAL = _Rmpc_out_strS (aTHX_ stream, base, dig, p, round, suff);
#line 8552 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__Rmpc_out_strP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__Rmpc_out_strP)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "pre, stream, base, dig, p, round");
    {
	SV *	pre = ST(0)
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(4))))
;
	SV *	round = ST(5)
;
	SV *	RETVAL;
#line 5625 "MPC.xs"
  RETVAL = _Rmpc_out_strP (aTHX_ pre, stream, base, dig, p, round);
#line 8582 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__Rmpc_out_strPS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__Rmpc_out_strPS)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "pre, stream, base, dig, p, round, suff");
    {
	SV *	pre = ST(0)
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(4))))
;
	SV *	round = ST(5)
;
	SV *	suff = ST(6)
;
	SV *	RETVAL;
#line 5638 "MPC.xs"
  RETVAL = _Rmpc_out_strPS (aTHX_ pre, stream, base, dig, p, round, suff);
#line 8614 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_inp_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_inp_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, stream, base, round");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 5648 "MPC.xs"
  RETVAL = Rmpc_inp_str (aTHX_ p, stream, base, round);
#line 8641 "MPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5657 "MPC.xs"
  RETVAL = Rmpc_sin (aTHX_ rop, op, round);
#line 8664 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5666 "MPC.xs"
  RETVAL = Rmpc_cos (aTHX_ rop, op, round);
#line 8688 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_tan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_tan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5675 "MPC.xs"
  RETVAL = Rmpc_tan (aTHX_ rop, op, round);
#line 8712 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sinh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sinh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5684 "MPC.xs"
  RETVAL = Rmpc_sinh (aTHX_ rop, op, round);
#line 8736 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_cosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_cosh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5693 "MPC.xs"
  RETVAL = Rmpc_cosh (aTHX_ rop, op, round);
#line 8760 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_tanh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_tanh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5702 "MPC.xs"
  RETVAL = Rmpc_tanh (aTHX_ rop, op, round);
#line 8784 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_asin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_asin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5711 "MPC.xs"
  RETVAL = Rmpc_asin (aTHX_ rop, op, round);
#line 8808 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_acos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_acos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5720 "MPC.xs"
  RETVAL = Rmpc_acos (aTHX_ rop, op, round);
#line 8832 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_atan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_atan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5729 "MPC.xs"
  RETVAL = Rmpc_atan (aTHX_ rop, op, round);
#line 8856 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_asinh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_asinh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5738 "MPC.xs"
  RETVAL = Rmpc_asinh (aTHX_ rop, op, round);
#line 8880 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_acosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_acosh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5747 "MPC.xs"
  RETVAL = Rmpc_acosh (aTHX_ rop, op, round);
#line 8904 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_atanh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_atanh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 5756 "MPC.xs"
  RETVAL = Rmpc_atanh (aTHX_ rop, op, round);
#line 8928 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_true); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_true)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, second, third");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5765 "MPC.xs"
  RETVAL = overload_true (aTHX_ a, second, third);
#line 8952 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5774 "MPC.xs"
  RETVAL = overload_mul (aTHX_ a, b, third);
#line 8976 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5783 "MPC.xs"
  RETVAL = overload_add (aTHX_ a, b, third);
#line 9000 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5792 "MPC.xs"
  RETVAL = overload_sub (aTHX_ a, b, third);
#line 9024 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5801 "MPC.xs"
  RETVAL = overload_div (aTHX_ a, b, third);
#line 9048 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_div_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_div_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5810 "MPC.xs"
  RETVAL = overload_div_eq (aTHX_ a, b, third);
#line 9072 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_sub_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_sub_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5819 "MPC.xs"
  RETVAL = overload_sub_eq (aTHX_ a, b, third);
#line 9096 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_add_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_add_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5828 "MPC.xs"
  RETVAL = overload_add_eq (aTHX_ a, b, third);
#line 9120 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_mul_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_mul_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5837 "MPC.xs"
  RETVAL = overload_mul_eq (aTHX_ a, b, third);
#line 9144 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5846 "MPC.xs"
  RETVAL = overload_pow (aTHX_ a, b, third);
#line 9168 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_pow_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_pow_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5855 "MPC.xs"
  RETVAL = overload_pow_eq (aTHX_ a, b, third);
#line 9192 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5864 "MPC.xs"
  RETVAL = overload_equiv (aTHX_ a, b, third);
#line 9216 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_not)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, second, third");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5873 "MPC.xs"
  RETVAL = overload_not (aTHX_ a, second, third);
#line 9240 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5882 "MPC.xs"
  RETVAL = overload_sqrt (aTHX_ p, second, third);
#line 9264 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_copy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
#line 5891 "MPC.xs"
        I32* temp;
#line 9289 "MPC.c"
#line 5893 "MPC.xs"
        temp = PL_markstack_ptr++;
        overload_copy(aTHX_ p, second, third);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9300 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_overload_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5909 "MPC.xs"
  RETVAL = overload_abs (aTHX_ p, second, third);
#line 9323 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5918 "MPC.xs"
  RETVAL = overload_exp (aTHX_ p, second, third);
#line 9347 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5927 "MPC.xs"
  RETVAL = overload_log (aTHX_ p, second, third);
#line 9371 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5936 "MPC.xs"
  RETVAL = overload_sin (aTHX_ p, second, third);
#line 9395 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_overload_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 5945 "MPC.xs"
  RETVAL = overload_cos (aTHX_ p, second, third);
#line 9419 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__get_r_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__get_r_string)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, base, n_digits, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	n_digits = ST(2)
;
	SV *	round = ST(3)
;
#line 5955 "MPC.xs"
        I32* temp;
#line 9446 "MPC.c"
#line 5957 "MPC.xs"
        temp = PL_markstack_ptr++;
        _get_r_string(aTHX_ p, base, n_digits, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9457 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC__get_i_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__get_i_string)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, base, n_digits, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	n_digits = ST(2)
;
	SV *	round = ST(3)
;
#line 5974 "MPC.xs"
        I32* temp;
#line 9483 "MPC.c"
#line 5976 "MPC.xs"
        temp = PL_markstack_ptr++;
        _get_i_string(aTHX_ p, base, n_digits, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9494 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC__itsa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__itsa)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	SV *	a = ST(0)
;
	SV *	RETVAL;
#line 5990 "MPC.xs"
  RETVAL = _itsa (aTHX_ a);
#line 9513 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__new_real_im); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__new_real_im)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "b, d");
    {
	SV *	b = ST(0)
;
	SV *	d = ST(1)
;
	SV *	RETVAL;
#line 5998 "MPC.xs"
  RETVAL = _new_real_im (aTHX_ b, d);
#line 9535 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__has_longlong); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__has_longlong)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_longlong();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__has_longdouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__has_longdouble)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_longdouble();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__has_inttypes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__has_inttypes)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_inttypes();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_gmp_v); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_gmp_v)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6015 "MPC.xs"
  RETVAL = gmp_v (aTHX);
#line 9604 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_mpfr_v); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_mpfr_v)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6022 "MPC.xs"
  RETVAL = mpfr_v (aTHX);
#line 9622 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__MPC_VERSION_MAJOR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__MPC_VERSION_MAJOR)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6029 "MPC.xs"
  RETVAL = _MPC_VERSION_MAJOR (aTHX);
#line 9640 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__MPC_VERSION_MINOR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__MPC_VERSION_MINOR)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6036 "MPC.xs"
  RETVAL = _MPC_VERSION_MINOR (aTHX);
#line 9658 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__MPC_VERSION_PATCHLEVEL); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__MPC_VERSION_PATCHLEVEL)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6043 "MPC.xs"
  RETVAL = _MPC_VERSION_PATCHLEVEL (aTHX);
#line 9676 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__MPC_VERSION); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__MPC_VERSION)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6050 "MPC.xs"
  RETVAL = _MPC_VERSION (aTHX);
#line 9694 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__MPFR_VERSION); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__MPFR_VERSION)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6057 "MPC.xs"
  RETVAL = _MPFR_VERSION (aTHX);
#line 9712 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__MPC_VERSION_NUM); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__MPC_VERSION_NUM)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "x, y, z");
    {
	SV *	x = ST(0)
;
	SV *	y = ST(1)
;
	SV *	z = ST(2)
;
	SV *	RETVAL;
#line 6067 "MPC.xs"
  RETVAL = _MPC_VERSION_NUM (aTHX_ x, y, z);
#line 9736 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__MPC_VERSION_STRING); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__MPC_VERSION_STRING)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6073 "MPC.xs"
  RETVAL = _MPC_VERSION_STRING (aTHX);
#line 9754 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6080 "MPC.xs"
  RETVAL = Rmpc_get_version (aTHX);
#line 9772 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_real); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_real)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6090 "MPC.xs"
  RETVAL = Rmpc_real (aTHX_ rop, op, round);
#line 9796 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_imag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_imag)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6099 "MPC.xs"
  RETVAL = Rmpc_imag (aTHX_ rop, op, round);
#line 9820 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_arg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_arg)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6108 "MPC.xs"
  RETVAL = Rmpc_arg (aTHX_ rop, op, round);
#line 9844 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_proj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_proj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6117 "MPC.xs"
  RETVAL = Rmpc_proj (aTHX_ rop, op, round);
#line 9868 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "base, dig, op, round");
    {
	SV *	base = ST(0)
;
	SV *	dig = ST(1)
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6127 "MPC.xs"
  RETVAL = Rmpc_get_str (aTHX_ base, dig, op, round);
#line 9894 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, str, base, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	str = ST(1)
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 6137 "MPC.xs"
  RETVAL = Rmpc_set_str (aTHX_ rop, str, base, round);
#line 9921 "MPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_strtoc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_strtoc)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, str, base, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	str = ST(1)
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 6147 "MPC.xs"
  RETVAL = Rmpc_strtoc (aTHX_ rop, str, base, round);
#line 9947 "MPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_nan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_nan)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
#line 6154 "MPC.xs"
        I32* temp;
#line 9967 "MPC.c"
#line 6156 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_set_nan(a);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9978 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_swap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_swap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
#line 6171 "MPC.xs"
        I32* temp;
#line 10000 "MPC.c"
#line 6173 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_swap(a, b);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10011 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_overload_atan2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_overload_atan2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, third");
    {
	mpc_t *            p = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            q = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 6189 "MPC.xs"
  RETVAL = overload_atan2 (aTHX_ p, q, third);
#line 10034 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sin_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sin_cos)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "rop_sin, rop_cos, op, rnd_sin, rnd_cos");
    {
	mpc_t *            rop_sin = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            rop_cos = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	SV *	rnd_sin = ST(3)
;
	SV *	rnd_cos = ST(4)
;
	SV *	RETVAL;
#line 6200 "MPC.xs"
  RETVAL = Rmpc_sin_cos (aTHX_ rop_sin, rop_cos, op, rnd_sin, rnd_cos);
#line 10062 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_dc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_dc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "crop, op, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	crop = ST(0)
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
#line 6209 "MPC.xs"
        I32* temp;
#line 10087 "MPC.c"
#line 6211 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_get_dc(aTHX_ crop, op, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10098 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_ldc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_ldc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "crop, op, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	crop = ST(0)
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
#line 6227 "MPC.xs"
        I32* temp;
#line 10122 "MPC.c"
#line 6229 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_get_ldc(aTHX_ crop, op, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10133 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_dc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_dc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "op, crop, round");
    {
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	crop = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6245 "MPC.xs"
  RETVAL = Rmpc_set_dc (aTHX_ op, crop, round);
#line 10156 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_ldc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_ldc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "op, crop, round");
    {
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	crop = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6254 "MPC.xs"
  RETVAL = Rmpc_set_ldc (aTHX_ op, crop, round);
#line 10180 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_DC); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_DC)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "crop, op, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	crop = ST(0)
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
#line 6263 "MPC.xs"
        I32* temp;
#line 10205 "MPC.c"
#line 6265 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_get_DC(aTHX_ crop, op, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10216 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_get_LDC); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_get_LDC)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "crop, op, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	crop = ST(0)
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
#line 6281 "MPC.xs"
        I32* temp;
#line 10240 "MPC.c"
#line 6283 "MPC.xs"
        temp = PL_markstack_ptr++;
        Rmpc_get_LDC(aTHX_ crop, op, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10251 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_DC); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_DC)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "op, crop, round");
    {
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	crop = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6299 "MPC.xs"
  RETVAL = Rmpc_set_DC (aTHX_ op, crop, round);
#line 10274 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_set_LDC); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_set_LDC)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "op, crop, round");
    {
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	crop = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6308 "MPC.xs"
  RETVAL = Rmpc_set_LDC (aTHX_ op, crop, round);
#line 10298 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__have_Complex_h); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__have_Complex_h)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _have_Complex_h();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__mpfr_buildopt_tls_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__mpfr_buildopt_tls_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6318 "MPC.xs"
  RETVAL = _mpfr_buildopt_tls_p (aTHX);
#line 10333 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__get_xs_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__get_xs_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6325 "MPC.xs"
  RETVAL = _get_xs_version (aTHX);
#line 10351 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__wrap_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__wrap_count)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6332 "MPC.xs"
  RETVAL = _wrap_count (aTHX);
#line 10369 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_mul_2si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_mul_2si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6343 "MPC.xs"
  RETVAL = Rmpc_mul_2si (aTHX_ a, b, c, round);
#line 10395 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_div_2si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_div_2si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6353 "MPC.xs"
  RETVAL = Rmpc_div_2si (aTHX_ a, b, c, round);
#line 10421 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_log10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_log10)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6362 "MPC.xs"
  RETVAL = Rmpc_log10 (aTHX_ rop, op, round);
#line 10445 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_cmp_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_cmp_abs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "op1, op2");
    {
	mpc_t *            op1 = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            op2 = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpc_cmp_abs(op1, op2);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_rootofunity); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_rootofunity)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, n, k, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	unsigned long	n = (unsigned long)SvUV(ST(1))
;
	unsigned long	k = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 6377 "MPC.xs"
  RETVAL = Rmpc_rootofunity (aTHX_ rop, n, k, round);
#line 10493 "MPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__can_pass_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__can_pass_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _can_pass_float128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__get_nv_precision); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__get_nv_precision)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _get_nv_precision();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_nok_pokflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_nok_pokflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nok_pokflag();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_clear_nok_pok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_clear_nok_pok)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 6396 "MPC.xs"
        I32* temp;
#line 10562 "MPC.c"
#line 6398 "MPC.xs"
        temp = PL_markstack_ptr++;
        clear_nok_pok();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10573 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC_set_nok_pok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_set_nok_pok)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 6412 "MPC.xs"
        I32* temp;
#line 10593 "MPC.c"
#line 6414 "MPC.xs"
        temp = PL_markstack_ptr++;
        set_nok_pok(x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10604 "MPC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPC__SvNOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__SvNOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 6428 "MPC.xs"
  RETVAL = _SvNOK (aTHX_ in);
#line 10624 "MPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC__SvPOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC__SvPOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 6435 "MPC.xs"
  RETVAL = _SvPOK (aTHX_ in);
#line 10644 "MPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_fma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_fma)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b, c, d, round");
    {
	mpc_t *            a = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	mpc_t *            b = INT2PTR(mpc_t *, SvIVX(SvRV(ST(1))))
;
	mpc_t *            c = INT2PTR(mpc_t *, SvIVX(SvRV(ST(2))))
;
	mpc_t *            d = INT2PTR(mpc_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 6446 "MPC.xs"
  RETVAL = Rmpc_fma (aTHX_ a, b, c, d, round);
#line 10671 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_dot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_dot)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "rop, avref_A, avref_B, len, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	avref_A = ST(1)
;
	SV *	avref_B = ST(2)
;
	SV *	len = ST(3)
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 6457 "MPC.xs"
  RETVAL = Rmpc_dot (aTHX_ rop, avref_A, avref_B, len, round);
#line 10699 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_Rmpc_sum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_Rmpc_sum)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, avref, len, round");
    {
	mpc_t *            rop = INT2PTR(mpc_t *, SvIVX(SvRV(ST(0))))
;
	SV *	avref = ST(1)
;
	SV *	len = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6467 "MPC.xs"
  RETVAL = Rmpc_sum (aTHX_ rop, avref, len, round);
#line 10725 "MPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPC_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPC_CLONE)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "x, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	x = ST(0)
;
#line 6474 "MPC.xs"
        I32* temp;
#line 10746 "MPC.c"
#line 6476 "MPC.xs"
        temp = PL_markstack_ptr++;
        CLONE(aTHX_ x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10757 "MPC.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Math__MPC); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__MPC)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::MPC::NOK_POK_val", XS_Math__MPC_NOK_POK_val);
        newXS_deffile("Math::MPC::_win32_infnanstring", XS_Math__MPC__win32_infnanstring);
        newXS_deffile("Math::MPC::Rmpc_mul_sj", XS_Math__MPC_Rmpc_mul_sj);
        newXS_deffile("Math::MPC::Rmpc_mul_ld", XS_Math__MPC_Rmpc_mul_ld);
        newXS_deffile("Math::MPC::Rmpc_mul_d", XS_Math__MPC_Rmpc_mul_d);
        newXS_deffile("Math::MPC::Rmpc_div_sj", XS_Math__MPC_Rmpc_div_sj);
        newXS_deffile("Math::MPC::Rmpc_sj_div", XS_Math__MPC_Rmpc_sj_div);
        newXS_deffile("Math::MPC::Rmpc_div_ld", XS_Math__MPC_Rmpc_div_ld);
        newXS_deffile("Math::MPC::Rmpc_ld_div", XS_Math__MPC_Rmpc_ld_div);
        newXS_deffile("Math::MPC::Rmpc_div_d", XS_Math__MPC_Rmpc_div_d);
        newXS_deffile("Math::MPC::Rmpc_d_div", XS_Math__MPC_Rmpc_d_div);
        newXS_deffile("Math::MPC::_mpfr_set_NV", XS_Math__MPC__mpfr_set_NV);
        newXS_deffile("Math::MPC::Rmpc_set_default_rounding_mode", XS_Math__MPC_Rmpc_set_default_rounding_mode);
        newXS_deffile("Math::MPC::Rmpc_get_default_rounding_mode", XS_Math__MPC_Rmpc_get_default_rounding_mode);
        newXS_deffile("Math::MPC::Rmpc_set_default_prec", XS_Math__MPC_Rmpc_set_default_prec);
        newXS_deffile("Math::MPC::Rmpc_set_default_prec2", XS_Math__MPC_Rmpc_set_default_prec2);
        newXS_deffile("Math::MPC::Rmpc_get_default_prec", XS_Math__MPC_Rmpc_get_default_prec);
        newXS_deffile("Math::MPC::Rmpc_get_default_prec2", XS_Math__MPC_Rmpc_get_default_prec2);
        newXS_deffile("Math::MPC::Rmpc_set_prec", XS_Math__MPC_Rmpc_set_prec);
        newXS_deffile("Math::MPC::Rmpc_set_re_prec", XS_Math__MPC_Rmpc_set_re_prec);
        newXS_deffile("Math::MPC::Rmpc_set_im_prec", XS_Math__MPC_Rmpc_set_im_prec);
        newXS_deffile("Math::MPC::Rmpc_get_prec", XS_Math__MPC_Rmpc_get_prec);
        newXS_deffile("Math::MPC::Rmpc_get_prec2", XS_Math__MPC_Rmpc_get_prec2);
        newXS_deffile("Math::MPC::Rmpc_get_im_prec", XS_Math__MPC_Rmpc_get_im_prec);
        newXS_deffile("Math::MPC::Rmpc_get_re_prec", XS_Math__MPC_Rmpc_get_re_prec);
        newXS_deffile("Math::MPC::RMPC_RE", XS_Math__MPC_RMPC_RE);
        newXS_deffile("Math::MPC::RMPC_IM", XS_Math__MPC_RMPC_IM);
        newXS_deffile("Math::MPC::RMPC_INEX_RE", XS_Math__MPC_RMPC_INEX_RE);
        newXS_deffile("Math::MPC::RMPC_INEX_IM", XS_Math__MPC_RMPC_INEX_IM);
        newXS_deffile("Math::MPC::DESTROY", XS_Math__MPC_DESTROY);
        newXS_deffile("Math::MPC::Rmpc_clear", XS_Math__MPC_Rmpc_clear);
        newXS_deffile("Math::MPC::Rmpc_clear_mpc", XS_Math__MPC_Rmpc_clear_mpc);
        newXS_deffile("Math::MPC::Rmpc_clear_ptr", XS_Math__MPC_Rmpc_clear_ptr);
        newXS_deffile("Math::MPC::Rmpc_init2", XS_Math__MPC_Rmpc_init2);
        newXS_deffile("Math::MPC::Rmpc_init3", XS_Math__MPC_Rmpc_init3);
        newXS_deffile("Math::MPC::Rmpc_init2_nobless", XS_Math__MPC_Rmpc_init2_nobless);
        newXS_deffile("Math::MPC::Rmpc_init3_nobless", XS_Math__MPC_Rmpc_init3_nobless);
        newXS_deffile("Math::MPC::Rmpc_set", XS_Math__MPC_Rmpc_set);
        newXS_deffile("Math::MPC::Rmpc_set_ui", XS_Math__MPC_Rmpc_set_ui);
        newXS_deffile("Math::MPC::Rmpc_set_si", XS_Math__MPC_Rmpc_set_si);
        newXS_deffile("Math::MPC::Rmpc_set_ld", XS_Math__MPC_Rmpc_set_ld);
        newXS_deffile("Math::MPC::Rmpc_set_NV", XS_Math__MPC_Rmpc_set_NV);
        newXS_deffile("Math::MPC::Rmpc_set_NV_NV", XS_Math__MPC_Rmpc_set_NV_NV);
        newXS_deffile("Math::MPC::Rmpc_set_uj", XS_Math__MPC_Rmpc_set_uj);
        newXS_deffile("Math::MPC::Rmpc_set_sj", XS_Math__MPC_Rmpc_set_sj);
        newXS_deffile("Math::MPC::Rmpc_set_z", XS_Math__MPC_Rmpc_set_z);
        newXS_deffile("Math::MPC::Rmpc_set_f", XS_Math__MPC_Rmpc_set_f);
        newXS_deffile("Math::MPC::Rmpc_set_q", XS_Math__MPC_Rmpc_set_q);
        newXS_deffile("Math::MPC::Rmpc_set_d", XS_Math__MPC_Rmpc_set_d);
        newXS_deffile("Math::MPC::Rmpc_set_fr", XS_Math__MPC_Rmpc_set_fr);
        newXS_deffile("Math::MPC::Rmpc_set_ui_ui", XS_Math__MPC_Rmpc_set_ui_ui);
        newXS_deffile("Math::MPC::Rmpc_set_si_si", XS_Math__MPC_Rmpc_set_si_si);
        newXS_deffile("Math::MPC::Rmpc_set_d_d", XS_Math__MPC_Rmpc_set_d_d);
        newXS_deffile("Math::MPC::Rmpc_set_ld_ld", XS_Math__MPC_Rmpc_set_ld_ld);
        newXS_deffile("Math::MPC::Rmpc_set_z_z", XS_Math__MPC_Rmpc_set_z_z);
        newXS_deffile("Math::MPC::Rmpc_set_q_q", XS_Math__MPC_Rmpc_set_q_q);
        newXS_deffile("Math::MPC::Rmpc_set_f_f", XS_Math__MPC_Rmpc_set_f_f);
        newXS_deffile("Math::MPC::Rmpc_set_fr_fr", XS_Math__MPC_Rmpc_set_fr_fr);
        newXS_deffile("Math::MPC::Rmpc_set_d_ui", XS_Math__MPC_Rmpc_set_d_ui);
        newXS_deffile("Math::MPC::Rmpc_set_d_si", XS_Math__MPC_Rmpc_set_d_si);
        newXS_deffile("Math::MPC::Rmpc_set_d_fr", XS_Math__MPC_Rmpc_set_d_fr);
        newXS_deffile("Math::MPC::Rmpc_set_ui_d", XS_Math__MPC_Rmpc_set_ui_d);
        newXS_deffile("Math::MPC::Rmpc_set_ui_si", XS_Math__MPC_Rmpc_set_ui_si);
        newXS_deffile("Math::MPC::Rmpc_set_ui_fr", XS_Math__MPC_Rmpc_set_ui_fr);
        newXS_deffile("Math::MPC::Rmpc_set_si_d", XS_Math__MPC_Rmpc_set_si_d);
        newXS_deffile("Math::MPC::Rmpc_set_si_ui", XS_Math__MPC_Rmpc_set_si_ui);
        newXS_deffile("Math::MPC::Rmpc_set_si_fr", XS_Math__MPC_Rmpc_set_si_fr);
        newXS_deffile("Math::MPC::Rmpc_set_fr_d", XS_Math__MPC_Rmpc_set_fr_d);
        newXS_deffile("Math::MPC::Rmpc_set_fr_ui", XS_Math__MPC_Rmpc_set_fr_ui);
        newXS_deffile("Math::MPC::Rmpc_set_fr_si", XS_Math__MPC_Rmpc_set_fr_si);
        newXS_deffile("Math::MPC::Rmpc_set_ld_ui", XS_Math__MPC_Rmpc_set_ld_ui);
        newXS_deffile("Math::MPC::Rmpc_set_ld_si", XS_Math__MPC_Rmpc_set_ld_si);
        newXS_deffile("Math::MPC::Rmpc_set_ld_fr", XS_Math__MPC_Rmpc_set_ld_fr);
        newXS_deffile("Math::MPC::Rmpc_set_ui_ld", XS_Math__MPC_Rmpc_set_ui_ld);
        newXS_deffile("Math::MPC::Rmpc_set_si_ld", XS_Math__MPC_Rmpc_set_si_ld);
        newXS_deffile("Math::MPC::Rmpc_set_fr_ld", XS_Math__MPC_Rmpc_set_fr_ld);
        newXS_deffile("Math::MPC::Rmpc_set_d_uj", XS_Math__MPC_Rmpc_set_d_uj);
        newXS_deffile("Math::MPC::Rmpc_set_d_sj", XS_Math__MPC_Rmpc_set_d_sj);
        newXS_deffile("Math::MPC::Rmpc_set_sj_d", XS_Math__MPC_Rmpc_set_sj_d);
        newXS_deffile("Math::MPC::Rmpc_set_uj_d", XS_Math__MPC_Rmpc_set_uj_d);
        newXS_deffile("Math::MPC::Rmpc_set_uj_fr", XS_Math__MPC_Rmpc_set_uj_fr);
        newXS_deffile("Math::MPC::Rmpc_set_sj_fr", XS_Math__MPC_Rmpc_set_sj_fr);
        newXS_deffile("Math::MPC::Rmpc_set_fr_uj", XS_Math__MPC_Rmpc_set_fr_uj);
        newXS_deffile("Math::MPC::Rmpc_set_fr_sj", XS_Math__MPC_Rmpc_set_fr_sj);
        newXS_deffile("Math::MPC::Rmpc_set_uj_sj", XS_Math__MPC_Rmpc_set_uj_sj);
        newXS_deffile("Math::MPC::Rmpc_set_sj_uj", XS_Math__MPC_Rmpc_set_sj_uj);
        newXS_deffile("Math::MPC::Rmpc_set_ld_uj", XS_Math__MPC_Rmpc_set_ld_uj);
        newXS_deffile("Math::MPC::Rmpc_set_ld_sj", XS_Math__MPC_Rmpc_set_ld_sj);
        newXS_deffile("Math::MPC::Rmpc_set_uj_ld", XS_Math__MPC_Rmpc_set_uj_ld);
        newXS_deffile("Math::MPC::Rmpc_set_sj_ld", XS_Math__MPC_Rmpc_set_sj_ld);
        newXS_deffile("Math::MPC::Rmpc_set_f_ui", XS_Math__MPC_Rmpc_set_f_ui);
        newXS_deffile("Math::MPC::Rmpc_set_q_ui", XS_Math__MPC_Rmpc_set_q_ui);
        newXS_deffile("Math::MPC::Rmpc_set_z_ui", XS_Math__MPC_Rmpc_set_z_ui);
        newXS_deffile("Math::MPC::Rmpc_set_f_si", XS_Math__MPC_Rmpc_set_f_si);
        newXS_deffile("Math::MPC::Rmpc_set_q_si", XS_Math__MPC_Rmpc_set_q_si);
        newXS_deffile("Math::MPC::Rmpc_set_z_si", XS_Math__MPC_Rmpc_set_z_si);
        newXS_deffile("Math::MPC::Rmpc_set_f_d", XS_Math__MPC_Rmpc_set_f_d);
        newXS_deffile("Math::MPC::Rmpc_set_q_d", XS_Math__MPC_Rmpc_set_q_d);
        newXS_deffile("Math::MPC::Rmpc_set_z_d", XS_Math__MPC_Rmpc_set_z_d);
        newXS_deffile("Math::MPC::Rmpc_set_f_uj", XS_Math__MPC_Rmpc_set_f_uj);
        newXS_deffile("Math::MPC::Rmpc_set_q_uj", XS_Math__MPC_Rmpc_set_q_uj);
        newXS_deffile("Math::MPC::Rmpc_set_z_uj", XS_Math__MPC_Rmpc_set_z_uj);
        newXS_deffile("Math::MPC::Rmpc_set_f_sj", XS_Math__MPC_Rmpc_set_f_sj);
        newXS_deffile("Math::MPC::Rmpc_set_q_sj", XS_Math__MPC_Rmpc_set_q_sj);
        newXS_deffile("Math::MPC::Rmpc_set_z_sj", XS_Math__MPC_Rmpc_set_z_sj);
        newXS_deffile("Math::MPC::Rmpc_set_f_ld", XS_Math__MPC_Rmpc_set_f_ld);
        newXS_deffile("Math::MPC::Rmpc_set_q_ld", XS_Math__MPC_Rmpc_set_q_ld);
        newXS_deffile("Math::MPC::Rmpc_set_z_ld", XS_Math__MPC_Rmpc_set_z_ld);
        newXS_deffile("Math::MPC::Rmpc_set_ui_f", XS_Math__MPC_Rmpc_set_ui_f);
        newXS_deffile("Math::MPC::Rmpc_set_ui_q", XS_Math__MPC_Rmpc_set_ui_q);
        newXS_deffile("Math::MPC::Rmpc_set_ui_z", XS_Math__MPC_Rmpc_set_ui_z);
        newXS_deffile("Math::MPC::Rmpc_set_si_f", XS_Math__MPC_Rmpc_set_si_f);
        newXS_deffile("Math::MPC::Rmpc_set_si_q", XS_Math__MPC_Rmpc_set_si_q);
        newXS_deffile("Math::MPC::Rmpc_set_si_z", XS_Math__MPC_Rmpc_set_si_z);
        newXS_deffile("Math::MPC::Rmpc_set_d_f", XS_Math__MPC_Rmpc_set_d_f);
        newXS_deffile("Math::MPC::Rmpc_set_d_q", XS_Math__MPC_Rmpc_set_d_q);
        newXS_deffile("Math::MPC::Rmpc_set_d_z", XS_Math__MPC_Rmpc_set_d_z);
        newXS_deffile("Math::MPC::Rmpc_set_uj_f", XS_Math__MPC_Rmpc_set_uj_f);
        newXS_deffile("Math::MPC::Rmpc_set_uj_q", XS_Math__MPC_Rmpc_set_uj_q);
        newXS_deffile("Math::MPC::Rmpc_set_uj_z", XS_Math__MPC_Rmpc_set_uj_z);
        newXS_deffile("Math::MPC::Rmpc_set_sj_f", XS_Math__MPC_Rmpc_set_sj_f);
        newXS_deffile("Math::MPC::Rmpc_set_sj_q", XS_Math__MPC_Rmpc_set_sj_q);
        newXS_deffile("Math::MPC::Rmpc_set_sj_z", XS_Math__MPC_Rmpc_set_sj_z);
        newXS_deffile("Math::MPC::Rmpc_set_ld_f", XS_Math__MPC_Rmpc_set_ld_f);
        newXS_deffile("Math::MPC::Rmpc_set_ld_q", XS_Math__MPC_Rmpc_set_ld_q);
        newXS_deffile("Math::MPC::Rmpc_set_ld_z", XS_Math__MPC_Rmpc_set_ld_z);
        newXS_deffile("Math::MPC::Rmpc_set_f_q", XS_Math__MPC_Rmpc_set_f_q);
        newXS_deffile("Math::MPC::Rmpc_set_q_f", XS_Math__MPC_Rmpc_set_q_f);
        newXS_deffile("Math::MPC::Rmpc_set_f_z", XS_Math__MPC_Rmpc_set_f_z);
        newXS_deffile("Math::MPC::Rmpc_set_z_f", XS_Math__MPC_Rmpc_set_z_f);
        newXS_deffile("Math::MPC::Rmpc_set_q_z", XS_Math__MPC_Rmpc_set_q_z);
        newXS_deffile("Math::MPC::Rmpc_set_z_q", XS_Math__MPC_Rmpc_set_z_q);
        newXS_deffile("Math::MPC::Rmpc_set_f_fr", XS_Math__MPC_Rmpc_set_f_fr);
        newXS_deffile("Math::MPC::Rmpc_set_fr_f", XS_Math__MPC_Rmpc_set_fr_f);
        newXS_deffile("Math::MPC::Rmpc_set_q_fr", XS_Math__MPC_Rmpc_set_q_fr);
        newXS_deffile("Math::MPC::Rmpc_set_fr_q", XS_Math__MPC_Rmpc_set_fr_q);
        newXS_deffile("Math::MPC::Rmpc_set_z_fr", XS_Math__MPC_Rmpc_set_z_fr);
        newXS_deffile("Math::MPC::Rmpc_set_fr_z", XS_Math__MPC_Rmpc_set_fr_z);
        newXS_deffile("Math::MPC::Rmpc_set_uj_uj", XS_Math__MPC_Rmpc_set_uj_uj);
        newXS_deffile("Math::MPC::Rmpc_set_sj_sj", XS_Math__MPC_Rmpc_set_sj_sj);
        newXS_deffile("Math::MPC::Rmpc_add", XS_Math__MPC_Rmpc_add);
        newXS_deffile("Math::MPC::Rmpc_add_ui", XS_Math__MPC_Rmpc_add_ui);
        newXS_deffile("Math::MPC::Rmpc_add_fr", XS_Math__MPC_Rmpc_add_fr);
        newXS_deffile("Math::MPC::Rmpc_sub", XS_Math__MPC_Rmpc_sub);
        newXS_deffile("Math::MPC::Rmpc_sub_ui", XS_Math__MPC_Rmpc_sub_ui);
        newXS_deffile("Math::MPC::Rmpc_ui_sub", XS_Math__MPC_Rmpc_ui_sub);
        newXS_deffile("Math::MPC::Rmpc_ui_ui_sub", XS_Math__MPC_Rmpc_ui_ui_sub);
        newXS_deffile("Math::MPC::Rmpc_mul", XS_Math__MPC_Rmpc_mul);
        newXS_deffile("Math::MPC::Rmpc_mul_ui", XS_Math__MPC_Rmpc_mul_ui);
        newXS_deffile("Math::MPC::Rmpc_mul_si", XS_Math__MPC_Rmpc_mul_si);
        newXS_deffile("Math::MPC::Rmpc_mul_fr", XS_Math__MPC_Rmpc_mul_fr);
        newXS_deffile("Math::MPC::Rmpc_mul_i", XS_Math__MPC_Rmpc_mul_i);
        newXS_deffile("Math::MPC::Rmpc_sqr", XS_Math__MPC_Rmpc_sqr);
        newXS_deffile("Math::MPC::Rmpc_div", XS_Math__MPC_Rmpc_div);
        newXS_deffile("Math::MPC::Rmpc_div_ui", XS_Math__MPC_Rmpc_div_ui);
        newXS_deffile("Math::MPC::Rmpc_ui_div", XS_Math__MPC_Rmpc_ui_div);
        newXS_deffile("Math::MPC::Rmpc_div_fr", XS_Math__MPC_Rmpc_div_fr);
        newXS_deffile("Math::MPC::Rmpc_sqrt", XS_Math__MPC_Rmpc_sqrt);
        newXS_deffile("Math::MPC::Rmpc_pow", XS_Math__MPC_Rmpc_pow);
        newXS_deffile("Math::MPC::Rmpc_pow_d", XS_Math__MPC_Rmpc_pow_d);
        newXS_deffile("Math::MPC::Rmpc_pow_ld", XS_Math__MPC_Rmpc_pow_ld);
        newXS_deffile("Math::MPC::Rmpc_pow_si", XS_Math__MPC_Rmpc_pow_si);
        newXS_deffile("Math::MPC::Rmpc_pow_ui", XS_Math__MPC_Rmpc_pow_ui);
        newXS_deffile("Math::MPC::Rmpc_pow_z", XS_Math__MPC_Rmpc_pow_z);
        newXS_deffile("Math::MPC::Rmpc_pow_fr", XS_Math__MPC_Rmpc_pow_fr);
        newXS_deffile("Math::MPC::Rmpc_neg", XS_Math__MPC_Rmpc_neg);
        newXS_deffile("Math::MPC::Rmpc_abs", XS_Math__MPC_Rmpc_abs);
        newXS_deffile("Math::MPC::Rmpc_conj", XS_Math__MPC_Rmpc_conj);
        newXS_deffile("Math::MPC::Rmpc_norm", XS_Math__MPC_Rmpc_norm);
        newXS_deffile("Math::MPC::Rmpc_mul_2ui", XS_Math__MPC_Rmpc_mul_2ui);
        newXS_deffile("Math::MPC::Rmpc_div_2ui", XS_Math__MPC_Rmpc_div_2ui);
        newXS_deffile("Math::MPC::Rmpc_cmp", XS_Math__MPC_Rmpc_cmp);
        newXS_deffile("Math::MPC::Rmpc_cmp_si", XS_Math__MPC_Rmpc_cmp_si);
        newXS_deffile("Math::MPC::Rmpc_cmp_si_si", XS_Math__MPC_Rmpc_cmp_si_si);
        newXS_deffile("Math::MPC::Rmpc_exp", XS_Math__MPC_Rmpc_exp);
        newXS_deffile("Math::MPC::Rmpc_log", XS_Math__MPC_Rmpc_log);
        newXS_deffile("Math::MPC::_Rmpc_out_str", XS_Math__MPC__Rmpc_out_str);
        newXS_deffile("Math::MPC::_Rmpc_out_strS", XS_Math__MPC__Rmpc_out_strS);
        newXS_deffile("Math::MPC::_Rmpc_out_strP", XS_Math__MPC__Rmpc_out_strP);
        newXS_deffile("Math::MPC::_Rmpc_out_strPS", XS_Math__MPC__Rmpc_out_strPS);
        newXS_deffile("Math::MPC::Rmpc_inp_str", XS_Math__MPC_Rmpc_inp_str);
        newXS_deffile("Math::MPC::Rmpc_sin", XS_Math__MPC_Rmpc_sin);
        newXS_deffile("Math::MPC::Rmpc_cos", XS_Math__MPC_Rmpc_cos);
        newXS_deffile("Math::MPC::Rmpc_tan", XS_Math__MPC_Rmpc_tan);
        newXS_deffile("Math::MPC::Rmpc_sinh", XS_Math__MPC_Rmpc_sinh);
        newXS_deffile("Math::MPC::Rmpc_cosh", XS_Math__MPC_Rmpc_cosh);
        newXS_deffile("Math::MPC::Rmpc_tanh", XS_Math__MPC_Rmpc_tanh);
        newXS_deffile("Math::MPC::Rmpc_asin", XS_Math__MPC_Rmpc_asin);
        newXS_deffile("Math::MPC::Rmpc_acos", XS_Math__MPC_Rmpc_acos);
        newXS_deffile("Math::MPC::Rmpc_atan", XS_Math__MPC_Rmpc_atan);
        newXS_deffile("Math::MPC::Rmpc_asinh", XS_Math__MPC_Rmpc_asinh);
        newXS_deffile("Math::MPC::Rmpc_acosh", XS_Math__MPC_Rmpc_acosh);
        newXS_deffile("Math::MPC::Rmpc_atanh", XS_Math__MPC_Rmpc_atanh);
        newXS_deffile("Math::MPC::overload_true", XS_Math__MPC_overload_true);
        newXS_deffile("Math::MPC::overload_mul", XS_Math__MPC_overload_mul);
        newXS_deffile("Math::MPC::overload_add", XS_Math__MPC_overload_add);
        newXS_deffile("Math::MPC::overload_sub", XS_Math__MPC_overload_sub);
        newXS_deffile("Math::MPC::overload_div", XS_Math__MPC_overload_div);
        newXS_deffile("Math::MPC::overload_div_eq", XS_Math__MPC_overload_div_eq);
        newXS_deffile("Math::MPC::overload_sub_eq", XS_Math__MPC_overload_sub_eq);
        newXS_deffile("Math::MPC::overload_add_eq", XS_Math__MPC_overload_add_eq);
        newXS_deffile("Math::MPC::overload_mul_eq", XS_Math__MPC_overload_mul_eq);
        newXS_deffile("Math::MPC::overload_pow", XS_Math__MPC_overload_pow);
        newXS_deffile("Math::MPC::overload_pow_eq", XS_Math__MPC_overload_pow_eq);
        newXS_deffile("Math::MPC::overload_equiv", XS_Math__MPC_overload_equiv);
        newXS_deffile("Math::MPC::overload_not", XS_Math__MPC_overload_not);
        newXS_deffile("Math::MPC::overload_sqrt", XS_Math__MPC_overload_sqrt);
        newXS_deffile("Math::MPC::overload_copy", XS_Math__MPC_overload_copy);
        newXS_deffile("Math::MPC::overload_abs", XS_Math__MPC_overload_abs);
        newXS_deffile("Math::MPC::overload_exp", XS_Math__MPC_overload_exp);
        newXS_deffile("Math::MPC::overload_log", XS_Math__MPC_overload_log);
        newXS_deffile("Math::MPC::overload_sin", XS_Math__MPC_overload_sin);
        newXS_deffile("Math::MPC::overload_cos", XS_Math__MPC_overload_cos);
        newXS_deffile("Math::MPC::_get_r_string", XS_Math__MPC__get_r_string);
        newXS_deffile("Math::MPC::_get_i_string", XS_Math__MPC__get_i_string);
        newXS_deffile("Math::MPC::_itsa", XS_Math__MPC__itsa);
        newXS_deffile("Math::MPC::_new_real_im", XS_Math__MPC__new_real_im);
        newXS_deffile("Math::MPC::_has_longlong", XS_Math__MPC__has_longlong);
        newXS_deffile("Math::MPC::_has_longdouble", XS_Math__MPC__has_longdouble);
        newXS_deffile("Math::MPC::_has_inttypes", XS_Math__MPC__has_inttypes);
        newXS_deffile("Math::MPC::gmp_v", XS_Math__MPC_gmp_v);
        newXS_deffile("Math::MPC::mpfr_v", XS_Math__MPC_mpfr_v);
        newXS_deffile("Math::MPC::_MPC_VERSION_MAJOR", XS_Math__MPC__MPC_VERSION_MAJOR);
        newXS_deffile("Math::MPC::_MPC_VERSION_MINOR", XS_Math__MPC__MPC_VERSION_MINOR);
        newXS_deffile("Math::MPC::_MPC_VERSION_PATCHLEVEL", XS_Math__MPC__MPC_VERSION_PATCHLEVEL);
        newXS_deffile("Math::MPC::_MPC_VERSION", XS_Math__MPC__MPC_VERSION);
        newXS_deffile("Math::MPC::_MPFR_VERSION", XS_Math__MPC__MPFR_VERSION);
        newXS_deffile("Math::MPC::_MPC_VERSION_NUM", XS_Math__MPC__MPC_VERSION_NUM);
        newXS_deffile("Math::MPC::_MPC_VERSION_STRING", XS_Math__MPC__MPC_VERSION_STRING);
        newXS_deffile("Math::MPC::Rmpc_get_version", XS_Math__MPC_Rmpc_get_version);
        newXS_deffile("Math::MPC::Rmpc_real", XS_Math__MPC_Rmpc_real);
        newXS_deffile("Math::MPC::Rmpc_imag", XS_Math__MPC_Rmpc_imag);
        newXS_deffile("Math::MPC::Rmpc_arg", XS_Math__MPC_Rmpc_arg);
        newXS_deffile("Math::MPC::Rmpc_proj", XS_Math__MPC_Rmpc_proj);
        newXS_deffile("Math::MPC::Rmpc_get_str", XS_Math__MPC_Rmpc_get_str);
        newXS_deffile("Math::MPC::Rmpc_set_str", XS_Math__MPC_Rmpc_set_str);
        newXS_deffile("Math::MPC::Rmpc_strtoc", XS_Math__MPC_Rmpc_strtoc);
        newXS_deffile("Math::MPC::Rmpc_set_nan", XS_Math__MPC_Rmpc_set_nan);
        newXS_deffile("Math::MPC::Rmpc_swap", XS_Math__MPC_Rmpc_swap);
        newXS_deffile("Math::MPC::overload_atan2", XS_Math__MPC_overload_atan2);
        newXS_deffile("Math::MPC::Rmpc_sin_cos", XS_Math__MPC_Rmpc_sin_cos);
        newXS_deffile("Math::MPC::Rmpc_get_dc", XS_Math__MPC_Rmpc_get_dc);
        newXS_deffile("Math::MPC::Rmpc_get_ldc", XS_Math__MPC_Rmpc_get_ldc);
        newXS_deffile("Math::MPC::Rmpc_set_dc", XS_Math__MPC_Rmpc_set_dc);
        newXS_deffile("Math::MPC::Rmpc_set_ldc", XS_Math__MPC_Rmpc_set_ldc);
        newXS_deffile("Math::MPC::Rmpc_get_DC", XS_Math__MPC_Rmpc_get_DC);
        newXS_deffile("Math::MPC::Rmpc_get_LDC", XS_Math__MPC_Rmpc_get_LDC);
        newXS_deffile("Math::MPC::Rmpc_set_DC", XS_Math__MPC_Rmpc_set_DC);
        newXS_deffile("Math::MPC::Rmpc_set_LDC", XS_Math__MPC_Rmpc_set_LDC);
        newXS_deffile("Math::MPC::_have_Complex_h", XS_Math__MPC__have_Complex_h);
        newXS_deffile("Math::MPC::_mpfr_buildopt_tls_p", XS_Math__MPC__mpfr_buildopt_tls_p);
        newXS_deffile("Math::MPC::_get_xs_version", XS_Math__MPC__get_xs_version);
        newXS_deffile("Math::MPC::_wrap_count", XS_Math__MPC__wrap_count);
        newXS_deffile("Math::MPC::Rmpc_mul_2si", XS_Math__MPC_Rmpc_mul_2si);
        newXS_deffile("Math::MPC::Rmpc_div_2si", XS_Math__MPC_Rmpc_div_2si);
        newXS_deffile("Math::MPC::Rmpc_log10", XS_Math__MPC_Rmpc_log10);
        newXS_deffile("Math::MPC::Rmpc_cmp_abs", XS_Math__MPC_Rmpc_cmp_abs);
        newXS_deffile("Math::MPC::Rmpc_rootofunity", XS_Math__MPC_Rmpc_rootofunity);
        newXS_deffile("Math::MPC::_can_pass_float128", XS_Math__MPC__can_pass_float128);
        newXS_deffile("Math::MPC::_get_nv_precision", XS_Math__MPC__get_nv_precision);
        newXS_deffile("Math::MPC::nok_pokflag", XS_Math__MPC_nok_pokflag);
        newXS_deffile("Math::MPC::clear_nok_pok", XS_Math__MPC_clear_nok_pok);
        newXS_deffile("Math::MPC::set_nok_pok", XS_Math__MPC_set_nok_pok);
        newXS_deffile("Math::MPC::_SvNOK", XS_Math__MPC__SvNOK);
        newXS_deffile("Math::MPC::_SvPOK", XS_Math__MPC__SvPOK);
        newXS_deffile("Math::MPC::Rmpc_fma", XS_Math__MPC_Rmpc_fma);
        newXS_deffile("Math::MPC::Rmpc_dot", XS_Math__MPC_Rmpc_dot);
        newXS_deffile("Math::MPC::Rmpc_sum", XS_Math__MPC_Rmpc_sum);
        newXS_deffile("Math::MPC::CLONE", XS_Math__MPC_CLONE);

    /* Initialisation Section */

#line 6487 "MPC.xs"

  {
  MY_CXT_INIT;
  MY_CXT._perl_default_prec_re = 53;
  MY_CXT._perl_default_prec_im = 53;
  MY_CXT._perl_default_rounding_mode = 0;
  }

#line 11072 "MPC.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

